package alliance

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// GetAlliancesAllianceIDCorporationsReader is a Reader for the GetAlliancesAllianceIDCorporations structure.
type GetAlliancesAllianceIDCorporationsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetAlliancesAllianceIDCorporationsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetAlliancesAllianceIDCorporationsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 500:
		result := NewGetAlliancesAllianceIDCorporationsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetAlliancesAllianceIDCorporationsOK creates a GetAlliancesAllianceIDCorporationsOK with default headers values
func NewGetAlliancesAllianceIDCorporationsOK() *GetAlliancesAllianceIDCorporationsOK {
	return &GetAlliancesAllianceIDCorporationsOK{}
}

/*GetAlliancesAllianceIDCorporationsOK handles this case with default header values.

List of corporation IDs
*/
type GetAlliancesAllianceIDCorporationsOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []int32
}

func (o *GetAlliancesAllianceIDCorporationsOK) Error() string {
	return fmt.Sprintf("[GET /alliances/{alliance_id}/corporations/][%d] getAlliancesAllianceIdCorporationsOK  %+v", 200, o.Payload)
}

func (o *GetAlliancesAllianceIDCorporationsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAlliancesAllianceIDCorporationsInternalServerError creates a GetAlliancesAllianceIDCorporationsInternalServerError with default headers values
func NewGetAlliancesAllianceIDCorporationsInternalServerError() *GetAlliancesAllianceIDCorporationsInternalServerError {
	return &GetAlliancesAllianceIDCorporationsInternalServerError{}
}

/*GetAlliancesAllianceIDCorporationsInternalServerError handles this case with default header values.

Internal server error
*/
type GetAlliancesAllianceIDCorporationsInternalServerError struct {
	Payload GetAlliancesAllianceIDCorporationsInternalServerErrorBody
}

func (o *GetAlliancesAllianceIDCorporationsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /alliances/{alliance_id}/corporations/][%d] getAlliancesAllianceIdCorporationsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetAlliancesAllianceIDCorporationsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetAlliancesAllianceIDCorporationsInternalServerErrorBody get_alliances_alliance_id_corporations_internal_server_error
//
// Internal server error
swagger:model GetAlliancesAllianceIDCorporationsInternalServerErrorBody
*/
type GetAlliancesAllianceIDCorporationsInternalServerErrorBody struct {

	// get_alliances_alliance_id_corporations_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}
