package assets

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// GetCharactersCharacterIDAssetsReader is a Reader for the GetCharactersCharacterIDAssets structure.
type GetCharactersCharacterIDAssetsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCharactersCharacterIDAssetsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetCharactersCharacterIDAssetsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewGetCharactersCharacterIDAssetsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetCharactersCharacterIDAssetsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCharactersCharacterIDAssetsOK creates a GetCharactersCharacterIDAssetsOK with default headers values
func NewGetCharactersCharacterIDAssetsOK() *GetCharactersCharacterIDAssetsOK {
	return &GetCharactersCharacterIDAssetsOK{}
}

/*GetCharactersCharacterIDAssetsOK handles this case with default header values.

A flat list of the users assets
*/
type GetCharactersCharacterIDAssetsOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetCharactersCharacterIDAssetsOKBodyItems0
}

func (o *GetCharactersCharacterIDAssetsOK) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/assets/][%d] getCharactersCharacterIdAssetsOK  %+v", 200, o.Payload)
}

func (o *GetCharactersCharacterIDAssetsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDAssetsForbidden creates a GetCharactersCharacterIDAssetsForbidden with default headers values
func NewGetCharactersCharacterIDAssetsForbidden() *GetCharactersCharacterIDAssetsForbidden {
	return &GetCharactersCharacterIDAssetsForbidden{}
}

/*GetCharactersCharacterIDAssetsForbidden handles this case with default header values.

Forbidden
*/
type GetCharactersCharacterIDAssetsForbidden struct {
	Payload GetCharactersCharacterIDAssetsForbiddenBody
}

func (o *GetCharactersCharacterIDAssetsForbidden) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/assets/][%d] getCharactersCharacterIdAssetsForbidden  %+v", 403, o.Payload)
}

func (o *GetCharactersCharacterIDAssetsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDAssetsInternalServerError creates a GetCharactersCharacterIDAssetsInternalServerError with default headers values
func NewGetCharactersCharacterIDAssetsInternalServerError() *GetCharactersCharacterIDAssetsInternalServerError {
	return &GetCharactersCharacterIDAssetsInternalServerError{}
}

/*GetCharactersCharacterIDAssetsInternalServerError handles this case with default header values.

Internal server error
*/
type GetCharactersCharacterIDAssetsInternalServerError struct {
	Payload GetCharactersCharacterIDAssetsInternalServerErrorBody
}

func (o *GetCharactersCharacterIDAssetsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/assets/][%d] getCharactersCharacterIdAssetsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCharactersCharacterIDAssetsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetCharactersCharacterIDAssetsOKBodyItems0 get_characters_character_id_assets_200_ok
//
// 200 ok object
swagger:model GetCharactersCharacterIDAssetsOKBodyItems0
*/
type GetCharactersCharacterIDAssetsOKBodyItems0 struct {

	// get_characters_character_id_assets_is_singleton
	//
	// is_singleton boolean
	// Required: true
	IsSingleton *bool `json:"is_singleton"`

	// get_characters_character_id_assets_item_id
	//
	// item_id integer
	// Required: true
	ItemID *int64 `json:"item_id"`

	// get_characters_character_id_assets_location_flag
	//
	// location_flag string
	// Required: true
	LocationFlag *string `json:"location_flag"`

	// get_characters_character_id_assets_location_id
	//
	// location_id integer
	// Required: true
	LocationID *int64 `json:"location_id"`

	// get_characters_character_id_assets_location_type
	//
	// location_type string
	// Required: true
	LocationType *string `json:"location_type"`

	// get_characters_character_id_assets_quantity
	//
	// quantity integer
	Quantity int32 `json:"quantity,omitempty"`

	// get_characters_character_id_assets_type_id
	//
	// type_id integer
	// Required: true
	TypeID *int32 `json:"type_id"`
}

/*GetCharactersCharacterIDAssetsForbiddenBody get_characters_character_id_assets_forbidden
//
// Forbidden
swagger:model GetCharactersCharacterIDAssetsForbiddenBody
*/
type GetCharactersCharacterIDAssetsForbiddenBody struct {

	// get_characters_character_id_assets_403_forbidden
	//
	// Forbidden message
	// Required: true
	Error *string `json:"error"`
}

/*GetCharactersCharacterIDAssetsInternalServerErrorBody get_characters_character_id_assets_internal_server_error
//
// Internal server error
swagger:model GetCharactersCharacterIDAssetsInternalServerErrorBody
*/
type GetCharactersCharacterIDAssetsInternalServerErrorBody struct {

	// get_characters_character_id_assets_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}
