package bookmarks

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// GetCharactersCharacterIDBookmarksReader is a Reader for the GetCharactersCharacterIDBookmarks structure.
type GetCharactersCharacterIDBookmarksReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCharactersCharacterIDBookmarksReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetCharactersCharacterIDBookmarksOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewGetCharactersCharacterIDBookmarksForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetCharactersCharacterIDBookmarksInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCharactersCharacterIDBookmarksOK creates a GetCharactersCharacterIDBookmarksOK with default headers values
func NewGetCharactersCharacterIDBookmarksOK() *GetCharactersCharacterIDBookmarksOK {
	return &GetCharactersCharacterIDBookmarksOK{}
}

/*GetCharactersCharacterIDBookmarksOK handles this case with default header values.

A list of bookmarks
*/
type GetCharactersCharacterIDBookmarksOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetCharactersCharacterIDBookmarksOKBodyItems0
}

func (o *GetCharactersCharacterIDBookmarksOK) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/bookmarks/][%d] getCharactersCharacterIdBookmarksOK  %+v", 200, o.Payload)
}

func (o *GetCharactersCharacterIDBookmarksOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDBookmarksForbidden creates a GetCharactersCharacterIDBookmarksForbidden with default headers values
func NewGetCharactersCharacterIDBookmarksForbidden() *GetCharactersCharacterIDBookmarksForbidden {
	return &GetCharactersCharacterIDBookmarksForbidden{}
}

/*GetCharactersCharacterIDBookmarksForbidden handles this case with default header values.

Forbidden
*/
type GetCharactersCharacterIDBookmarksForbidden struct {
	Payload GetCharactersCharacterIDBookmarksForbiddenBody
}

func (o *GetCharactersCharacterIDBookmarksForbidden) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/bookmarks/][%d] getCharactersCharacterIdBookmarksForbidden  %+v", 403, o.Payload)
}

func (o *GetCharactersCharacterIDBookmarksForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDBookmarksInternalServerError creates a GetCharactersCharacterIDBookmarksInternalServerError with default headers values
func NewGetCharactersCharacterIDBookmarksInternalServerError() *GetCharactersCharacterIDBookmarksInternalServerError {
	return &GetCharactersCharacterIDBookmarksInternalServerError{}
}

/*GetCharactersCharacterIDBookmarksInternalServerError handles this case with default header values.

Internal server error
*/
type GetCharactersCharacterIDBookmarksInternalServerError struct {
	Payload GetCharactersCharacterIDBookmarksInternalServerErrorBody
}

func (o *GetCharactersCharacterIDBookmarksInternalServerError) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/bookmarks/][%d] getCharactersCharacterIdBookmarksInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCharactersCharacterIDBookmarksInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetCharactersCharacterIDBookmarksOKBodyItems0 get_characters_character_id_bookmarks_200_ok
//
// 200 ok object
swagger:model GetCharactersCharacterIDBookmarksOKBodyItems0
*/
type GetCharactersCharacterIDBookmarksOKBodyItems0 struct {

	// get_characters_character_id_bookmarks_bookmark_id
	//
	// bookmark_id integer
	// Required: true
	BookmarkID *int64 `json:"bookmark_id"`

	// get_characters_character_id_bookmarks_create_date
	//
	// create_date string
	// Required: true
	CreateDate *strfmt.DateTime `json:"create_date"`

	// get_characters_character_id_bookmarks_creator_id
	//
	// creator_id integer
	// Required: true
	CreatorID *int32 `json:"creator_id"`

	// get_characters_character_id_bookmarks_folder_id
	//
	// folder_id integer
	FolderID int32 `json:"folder_id,omitempty"`

	// get_characters_character_id_bookmarks_memo
	//
	// memo string
	// Required: true
	Memo *string `json:"memo"`

	// get_characters_character_id_bookmarks_note
	//
	// note string
	// Required: true
	Note *string `json:"note"`

	// get_characters_character_id_bookmarks_owner_id
	//
	// owner_id integer
	// Required: true
	OwnerID *int32 `json:"owner_id"`

	// target
	// Required: true
	Target *GetCharactersCharacterIDBookmarksOKBodyItems0Target `json:"target"`
}

/*GetCharactersCharacterIDBookmarksOKBodyItems0Target get_characters_character_id_bookmarks_target
//
// target object
swagger:model GetCharactersCharacterIDBookmarksOKBodyItems0Target
*/
type GetCharactersCharacterIDBookmarksOKBodyItems0Target struct {

	// coordinates
	Coordinates *GetCharactersCharacterIDBookmarksOKBodyItems0TargetCoordinates `json:"coordinates,omitempty"`

	// item
	Item *GetCharactersCharacterIDBookmarksOKBodyItems0TargetItem `json:"item,omitempty"`

	// get_characters_character_id_bookmarks_location_id
	//
	// location_id integer
	// Required: true
	LocationID *int64 `json:"location_id"`
}

/*GetCharactersCharacterIDBookmarksOKBodyItems0TargetCoordinates get_characters_character_id_bookmarks_coordinates
//
// coordinates object
swagger:model GetCharactersCharacterIDBookmarksOKBodyItems0TargetCoordinates
*/
type GetCharactersCharacterIDBookmarksOKBodyItems0TargetCoordinates struct {

	// get_characters_character_id_bookmarks_x
	//
	// x number
	// Required: true
	X *float64 `json:"x"`

	// get_characters_character_id_bookmarks_y
	//
	// y number
	// Required: true
	Y *float64 `json:"y"`

	// get_characters_character_id_bookmarks_z
	//
	// z number
	// Required: true
	Z *float64 `json:"z"`
}

/*GetCharactersCharacterIDBookmarksOKBodyItems0TargetItem get_characters_character_id_bookmarks_item
//
// item object
swagger:model GetCharactersCharacterIDBookmarksOKBodyItems0TargetItem
*/
type GetCharactersCharacterIDBookmarksOKBodyItems0TargetItem struct {

	// get_characters_character_id_bookmarks_item_id
	//
	// item_id integer
	// Required: true
	ItemID *int64 `json:"item_id"`

	// get_characters_character_id_bookmarks_type_id
	//
	// type_id integer
	// Required: true
	TypeID *int32 `json:"type_id"`
}

/*GetCharactersCharacterIDBookmarksForbiddenBody get_characters_character_id_bookmarks_forbidden
//
// Forbidden
swagger:model GetCharactersCharacterIDBookmarksForbiddenBody
*/
type GetCharactersCharacterIDBookmarksForbiddenBody struct {

	// get_characters_character_id_bookmarks_403_forbidden
	//
	// Forbidden message
	// Required: true
	Error *string `json:"error"`
}

/*GetCharactersCharacterIDBookmarksInternalServerErrorBody get_characters_character_id_bookmarks_internal_server_error
//
// Internal server error
swagger:model GetCharactersCharacterIDBookmarksInternalServerErrorBody
*/
type GetCharactersCharacterIDBookmarksInternalServerErrorBody struct {

	// get_characters_character_id_bookmarks_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}
