package character

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// GetCharactersCharacterIDCorporationhistoryReader is a Reader for the GetCharactersCharacterIDCorporationhistory structure.
type GetCharactersCharacterIDCorporationhistoryReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCharactersCharacterIDCorporationhistoryReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetCharactersCharacterIDCorporationhistoryOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 500:
		result := NewGetCharactersCharacterIDCorporationhistoryInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCharactersCharacterIDCorporationhistoryOK creates a GetCharactersCharacterIDCorporationhistoryOK with default headers values
func NewGetCharactersCharacterIDCorporationhistoryOK() *GetCharactersCharacterIDCorporationhistoryOK {
	return &GetCharactersCharacterIDCorporationhistoryOK{}
}

/*GetCharactersCharacterIDCorporationhistoryOK handles this case with default header values.

Corporation history for the given character
*/
type GetCharactersCharacterIDCorporationhistoryOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetCharactersCharacterIDCorporationhistoryOKBodyItems0
}

func (o *GetCharactersCharacterIDCorporationhistoryOK) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/corporationhistory/][%d] getCharactersCharacterIdCorporationhistoryOK  %+v", 200, o.Payload)
}

func (o *GetCharactersCharacterIDCorporationhistoryOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDCorporationhistoryInternalServerError creates a GetCharactersCharacterIDCorporationhistoryInternalServerError with default headers values
func NewGetCharactersCharacterIDCorporationhistoryInternalServerError() *GetCharactersCharacterIDCorporationhistoryInternalServerError {
	return &GetCharactersCharacterIDCorporationhistoryInternalServerError{}
}

/*GetCharactersCharacterIDCorporationhistoryInternalServerError handles this case with default header values.

Internal server error
*/
type GetCharactersCharacterIDCorporationhistoryInternalServerError struct {
	Payload GetCharactersCharacterIDCorporationhistoryInternalServerErrorBody
}

func (o *GetCharactersCharacterIDCorporationhistoryInternalServerError) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/corporationhistory/][%d] getCharactersCharacterIdCorporationhistoryInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCharactersCharacterIDCorporationhistoryInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetCharactersCharacterIDCorporationhistoryOKBodyItems0 get_characters_character_id_corporationhistory_200_ok
//
// 200 ok object
swagger:model GetCharactersCharacterIDCorporationhistoryOKBodyItems0
*/
type GetCharactersCharacterIDCorporationhistoryOKBodyItems0 struct {

	// get_characters_character_id_corporationhistory_corporation_id
	//
	// corporation_id integer
	CorporationID int32 `json:"corporation_id,omitempty"`

	// get_characters_character_id_corporationhistory_is_deleted
	//
	// True if the corporation has been deleted
	IsDeleted bool `json:"is_deleted,omitempty"`

	// get_characters_character_id_corporationhistory_record_id
	//
	// An incrementing ID that can be used to canonically establish order of records in cases where dates may be ambiguous
	RecordID int32 `json:"record_id,omitempty"`

	// get_characters_character_id_corporationhistory_start_date
	//
	// start_date string
	StartDate strfmt.DateTime `json:"start_date,omitempty"`
}

/*GetCharactersCharacterIDCorporationhistoryInternalServerErrorBody get_characters_character_id_corporationhistory_internal_server_error
//
// Internal server error
swagger:model GetCharactersCharacterIDCorporationhistoryInternalServerErrorBody
*/
type GetCharactersCharacterIDCorporationhistoryInternalServerErrorBody struct {

	// get_characters_character_id_corporationhistory_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}
