package character

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// GetCharactersCharacterIDPortraitReader is a Reader for the GetCharactersCharacterIDPortrait structure.
type GetCharactersCharacterIDPortraitReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCharactersCharacterIDPortraitReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetCharactersCharacterIDPortraitOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 404:
		result := NewGetCharactersCharacterIDPortraitNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetCharactersCharacterIDPortraitInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCharactersCharacterIDPortraitOK creates a GetCharactersCharacterIDPortraitOK with default headers values
func NewGetCharactersCharacterIDPortraitOK() *GetCharactersCharacterIDPortraitOK {
	return &GetCharactersCharacterIDPortraitOK{}
}

/*GetCharactersCharacterIDPortraitOK handles this case with default header values.

Public data for the given character
*/
type GetCharactersCharacterIDPortraitOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload GetCharactersCharacterIDPortraitOKBody
}

func (o *GetCharactersCharacterIDPortraitOK) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/portrait/][%d] getCharactersCharacterIdPortraitOK  %+v", 200, o.Payload)
}

func (o *GetCharactersCharacterIDPortraitOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDPortraitNotFound creates a GetCharactersCharacterIDPortraitNotFound with default headers values
func NewGetCharactersCharacterIDPortraitNotFound() *GetCharactersCharacterIDPortraitNotFound {
	return &GetCharactersCharacterIDPortraitNotFound{}
}

/*GetCharactersCharacterIDPortraitNotFound handles this case with default header values.

No image server for this datasource
*/
type GetCharactersCharacterIDPortraitNotFound struct {
	Payload GetCharactersCharacterIDPortraitNotFoundBody
}

func (o *GetCharactersCharacterIDPortraitNotFound) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/portrait/][%d] getCharactersCharacterIdPortraitNotFound  %+v", 404, o.Payload)
}

func (o *GetCharactersCharacterIDPortraitNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDPortraitInternalServerError creates a GetCharactersCharacterIDPortraitInternalServerError with default headers values
func NewGetCharactersCharacterIDPortraitInternalServerError() *GetCharactersCharacterIDPortraitInternalServerError {
	return &GetCharactersCharacterIDPortraitInternalServerError{}
}

/*GetCharactersCharacterIDPortraitInternalServerError handles this case with default header values.

Internal server error
*/
type GetCharactersCharacterIDPortraitInternalServerError struct {
	Payload GetCharactersCharacterIDPortraitInternalServerErrorBody
}

func (o *GetCharactersCharacterIDPortraitInternalServerError) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/portrait/][%d] getCharactersCharacterIdPortraitInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCharactersCharacterIDPortraitInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetCharactersCharacterIDPortraitOKBody get_characters_character_id_portrait_ok
//
// 200 ok object
swagger:model GetCharactersCharacterIDPortraitOKBody
*/
type GetCharactersCharacterIDPortraitOKBody struct {

	// get_characters_character_id_portrait_px128x128
	//
	// px128x128 string
	// Required: true
	Px128x128 *string `json:"px128x128"`

	// get_characters_character_id_portrait_px256x256
	//
	// px256x256 string
	// Required: true
	Px256x256 *string `json:"px256x256"`

	// get_characters_character_id_portrait_px512x512
	//
	// px512x512 string
	// Required: true
	Px512x512 *string `json:"px512x512"`

	// get_characters_character_id_portrait_px64x64
	//
	// px64x64 string
	// Required: true
	Px64x64 *string `json:"px64x64"`
}

/*GetCharactersCharacterIDPortraitNotFoundBody get_characters_character_id_portrait_not_found
//
// No image server for this datasource
swagger:model GetCharactersCharacterIDPortraitNotFoundBody
*/
type GetCharactersCharacterIDPortraitNotFoundBody struct {

	// get_characters_character_id_portrait_error
	//
	// error message
	// Required: true
	Error *string `json:"error"`
}

/*GetCharactersCharacterIDPortraitInternalServerErrorBody get_characters_character_id_portrait_internal_server_error
//
// Internal server error
swagger:model GetCharactersCharacterIDPortraitInternalServerErrorBody
*/
type GetCharactersCharacterIDPortraitInternalServerErrorBody struct {

	// get_characters_character_id_portrait_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}
