package character

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// GetCharactersCharacterIDReader is a Reader for the GetCharactersCharacterID structure.
type GetCharactersCharacterIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCharactersCharacterIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetCharactersCharacterIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 404:
		result := NewGetCharactersCharacterIDNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetCharactersCharacterIDInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCharactersCharacterIDOK creates a GetCharactersCharacterIDOK with default headers values
func NewGetCharactersCharacterIDOK() *GetCharactersCharacterIDOK {
	return &GetCharactersCharacterIDOK{}
}

/*GetCharactersCharacterIDOK handles this case with default header values.

Public data for the given character
*/
type GetCharactersCharacterIDOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload GetCharactersCharacterIDOKBody
}

func (o *GetCharactersCharacterIDOK) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/][%d] getCharactersCharacterIdOK  %+v", 200, o.Payload)
}

func (o *GetCharactersCharacterIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDNotFound creates a GetCharactersCharacterIDNotFound with default headers values
func NewGetCharactersCharacterIDNotFound() *GetCharactersCharacterIDNotFound {
	return &GetCharactersCharacterIDNotFound{}
}

/*GetCharactersCharacterIDNotFound handles this case with default header values.

Character not found
*/
type GetCharactersCharacterIDNotFound struct {
	Payload GetCharactersCharacterIDNotFoundBody
}

func (o *GetCharactersCharacterIDNotFound) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/][%d] getCharactersCharacterIdNotFound  %+v", 404, o.Payload)
}

func (o *GetCharactersCharacterIDNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDInternalServerError creates a GetCharactersCharacterIDInternalServerError with default headers values
func NewGetCharactersCharacterIDInternalServerError() *GetCharactersCharacterIDInternalServerError {
	return &GetCharactersCharacterIDInternalServerError{}
}

/*GetCharactersCharacterIDInternalServerError handles this case with default header values.

Internal server error
*/
type GetCharactersCharacterIDInternalServerError struct {
	Payload GetCharactersCharacterIDInternalServerErrorBody
}

func (o *GetCharactersCharacterIDInternalServerError) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/][%d] getCharactersCharacterIdInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCharactersCharacterIDInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetCharactersCharacterIDOKBody get_characters_character_id_ok
//
// 200 ok object
swagger:model GetCharactersCharacterIDOKBody
*/
type GetCharactersCharacterIDOKBody struct {

	// get_characters_character_id_alliance_id
	//
	// The character's alliance ID
	// Required: true
	AllianceID *int32 `json:"alliance_id"`

	// get_characters_character_id_ancestry_id
	//
	// ancestry_id integer
	// Required: true
	AncestryID *int32 `json:"ancestry_id"`

	// get_characters_character_id_birthday
	//
	// Creation date of the character
	// Required: true
	Birthday *strfmt.DateTime `json:"birthday"`

	// get_characters_character_id_bloodline_id
	//
	// bloodline_id integer
	// Required: true
	BloodlineID *int32 `json:"bloodline_id"`

	// get_characters_character_id_corporation_id
	//
	// The character's corporation ID
	// Required: true
	CorporationID *int32 `json:"corporation_id"`

	// get_characters_character_id_description
	//
	// description string
	// Required: true
	Description *string `json:"description"`

	// get_characters_character_id_gender
	//
	// gender string
	// Required: true
	Gender *string `json:"gender"`

	// get_characters_character_id_name
	//
	// name string
	// Required: true
	Name *string `json:"name"`

	// get_characters_character_id_race_id
	//
	// race_id integer
	// Required: true
	RaceID *int32 `json:"race_id"`

	// get_characters_character_id_security_status
	//
	// security_status number
	// Required: true
	// Maximum: 10
	// Minimum: -10
	SecurityStatus *float32 `json:"security_status"`
}

/*GetCharactersCharacterIDNotFoundBody get_characters_character_id_not_found
//
// Not found
swagger:model GetCharactersCharacterIDNotFoundBody
*/
type GetCharactersCharacterIDNotFoundBody struct {

	// get_characters_character_id_404_not_found
	//
	// Not found message
	// Required: true
	Error *string `json:"error"`
}

/*GetCharactersCharacterIDInternalServerErrorBody get_characters_character_id_internal_server_error
//
// Internal server error
swagger:model GetCharactersCharacterIDInternalServerErrorBody
*/
type GetCharactersCharacterIDInternalServerErrorBody struct {

	// get_characters_character_id_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}
