package contacts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// DeleteCharactersCharacterIDContactsReader is a Reader for the DeleteCharactersCharacterIDContacts structure.
type DeleteCharactersCharacterIDContactsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteCharactersCharacterIDContactsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 204:
		result := NewDeleteCharactersCharacterIDContactsNoContent()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewDeleteCharactersCharacterIDContactsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewDeleteCharactersCharacterIDContactsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewDeleteCharactersCharacterIDContactsNoContent creates a DeleteCharactersCharacterIDContactsNoContent with default headers values
func NewDeleteCharactersCharacterIDContactsNoContent() *DeleteCharactersCharacterIDContactsNoContent {
	return &DeleteCharactersCharacterIDContactsNoContent{}
}

/*DeleteCharactersCharacterIDContactsNoContent handles this case with default header values.

Contacts deleted
*/
type DeleteCharactersCharacterIDContactsNoContent struct {
}

func (o *DeleteCharactersCharacterIDContactsNoContent) Error() string {
	return fmt.Sprintf("[DELETE /characters/{character_id}/contacts/][%d] deleteCharactersCharacterIdContactsNoContent ", 204)
}

func (o *DeleteCharactersCharacterIDContactsNoContent) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewDeleteCharactersCharacterIDContactsForbidden creates a DeleteCharactersCharacterIDContactsForbidden with default headers values
func NewDeleteCharactersCharacterIDContactsForbidden() *DeleteCharactersCharacterIDContactsForbidden {
	return &DeleteCharactersCharacterIDContactsForbidden{}
}

/*DeleteCharactersCharacterIDContactsForbidden handles this case with default header values.

Forbidden
*/
type DeleteCharactersCharacterIDContactsForbidden struct {
	Payload DeleteCharactersCharacterIDContactsForbiddenBody
}

func (o *DeleteCharactersCharacterIDContactsForbidden) Error() string {
	return fmt.Sprintf("[DELETE /characters/{character_id}/contacts/][%d] deleteCharactersCharacterIdContactsForbidden  %+v", 403, o.Payload)
}

func (o *DeleteCharactersCharacterIDContactsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteCharactersCharacterIDContactsInternalServerError creates a DeleteCharactersCharacterIDContactsInternalServerError with default headers values
func NewDeleteCharactersCharacterIDContactsInternalServerError() *DeleteCharactersCharacterIDContactsInternalServerError {
	return &DeleteCharactersCharacterIDContactsInternalServerError{}
}

/*DeleteCharactersCharacterIDContactsInternalServerError handles this case with default header values.

Internal server error
*/
type DeleteCharactersCharacterIDContactsInternalServerError struct {
	Payload DeleteCharactersCharacterIDContactsInternalServerErrorBody
}

func (o *DeleteCharactersCharacterIDContactsInternalServerError) Error() string {
	return fmt.Sprintf("[DELETE /characters/{character_id}/contacts/][%d] deleteCharactersCharacterIdContactsInternalServerError  %+v", 500, o.Payload)
}

func (o *DeleteCharactersCharacterIDContactsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*DeleteCharactersCharacterIDContactsForbiddenBody delete_characters_character_id_contacts_forbidden
//
// Forbidden
swagger:model DeleteCharactersCharacterIDContactsForbiddenBody
*/
type DeleteCharactersCharacterIDContactsForbiddenBody struct {

	// delete_characters_character_id_contacts_403_forbidden
	//
	// Forbidden message
	// Required: true
	Error *string `json:"error"`
}

/*DeleteCharactersCharacterIDContactsInternalServerErrorBody delete_characters_character_id_contacts_internal_server_error
//
// Internal server error
swagger:model DeleteCharactersCharacterIDContactsInternalServerErrorBody
*/
type DeleteCharactersCharacterIDContactsInternalServerErrorBody struct {

	// delete_characters_character_id_contacts_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}
