package contacts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// GetCharactersCharacterIDContactsReader is a Reader for the GetCharactersCharacterIDContacts structure.
type GetCharactersCharacterIDContactsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCharactersCharacterIDContactsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetCharactersCharacterIDContactsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewGetCharactersCharacterIDContactsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetCharactersCharacterIDContactsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCharactersCharacterIDContactsOK creates a GetCharactersCharacterIDContactsOK with default headers values
func NewGetCharactersCharacterIDContactsOK() *GetCharactersCharacterIDContactsOK {
	return &GetCharactersCharacterIDContactsOK{}
}

/*GetCharactersCharacterIDContactsOK handles this case with default header values.

A list of contacts
*/
type GetCharactersCharacterIDContactsOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetCharactersCharacterIDContactsOKBodyItems0
}

func (o *GetCharactersCharacterIDContactsOK) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/contacts/][%d] getCharactersCharacterIdContactsOK  %+v", 200, o.Payload)
}

func (o *GetCharactersCharacterIDContactsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDContactsForbidden creates a GetCharactersCharacterIDContactsForbidden with default headers values
func NewGetCharactersCharacterIDContactsForbidden() *GetCharactersCharacterIDContactsForbidden {
	return &GetCharactersCharacterIDContactsForbidden{}
}

/*GetCharactersCharacterIDContactsForbidden handles this case with default header values.

Forbidden
*/
type GetCharactersCharacterIDContactsForbidden struct {
	Payload GetCharactersCharacterIDContactsForbiddenBody
}

func (o *GetCharactersCharacterIDContactsForbidden) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/contacts/][%d] getCharactersCharacterIdContactsForbidden  %+v", 403, o.Payload)
}

func (o *GetCharactersCharacterIDContactsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDContactsInternalServerError creates a GetCharactersCharacterIDContactsInternalServerError with default headers values
func NewGetCharactersCharacterIDContactsInternalServerError() *GetCharactersCharacterIDContactsInternalServerError {
	return &GetCharactersCharacterIDContactsInternalServerError{}
}

/*GetCharactersCharacterIDContactsInternalServerError handles this case with default header values.

Internal server error
*/
type GetCharactersCharacterIDContactsInternalServerError struct {
	Payload GetCharactersCharacterIDContactsInternalServerErrorBody
}

func (o *GetCharactersCharacterIDContactsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/contacts/][%d] getCharactersCharacterIdContactsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCharactersCharacterIDContactsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetCharactersCharacterIDContactsOKBodyItems0 get_characters_character_id_contacts_200_ok
//
// 200 ok object
swagger:model GetCharactersCharacterIDContactsOKBodyItems0
*/
type GetCharactersCharacterIDContactsOKBodyItems0 struct {

	// get_characters_character_id_contacts_contact_id
	//
	// contact_id integer
	// Required: true
	ContactID *int32 `json:"contact_id"`

	// get_characters_character_id_contacts_contact_type
	//
	// contact_type string
	// Required: true
	ContactType *string `json:"contact_type"`

	// get_characters_character_id_contacts_is_blocked
	//
	// Whether this contact is in the blocked list. Note a missing value denotes unknown, not true or false
	IsBlocked bool `json:"is_blocked,omitempty"`

	// get_characters_character_id_contacts_is_watched
	//
	// Whether this contact is being watched
	IsWatched bool `json:"is_watched,omitempty"`

	// get_characters_character_id_contacts_label_id
	//
	// Custom label of the contact
	LabelID int64 `json:"label_id,omitempty"`

	// get_characters_character_id_contacts_standing
	//
	// Standing of the contact
	// Required: true
	Standing *float32 `json:"standing"`
}

/*GetCharactersCharacterIDContactsForbiddenBody get_characters_character_id_contacts_forbidden
//
// Forbidden
swagger:model GetCharactersCharacterIDContactsForbiddenBody
*/
type GetCharactersCharacterIDContactsForbiddenBody struct {

	// get_characters_character_id_contacts_403_forbidden
	//
	// Forbidden message
	// Required: true
	Error *string `json:"error"`
}

/*GetCharactersCharacterIDContactsInternalServerErrorBody get_characters_character_id_contacts_internal_server_error
//
// Internal server error
swagger:model GetCharactersCharacterIDContactsInternalServerErrorBody
*/
type GetCharactersCharacterIDContactsInternalServerErrorBody struct {

	// get_characters_character_id_contacts_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}
