package corporation

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// GetCorporationsCorporationIDMembersReader is a Reader for the GetCorporationsCorporationIDMembers structure.
type GetCorporationsCorporationIDMembersReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCorporationsCorporationIDMembersReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetCorporationsCorporationIDMembersOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewGetCorporationsCorporationIDMembersForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetCorporationsCorporationIDMembersInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCorporationsCorporationIDMembersOK creates a GetCorporationsCorporationIDMembersOK with default headers values
func NewGetCorporationsCorporationIDMembersOK() *GetCorporationsCorporationIDMembersOK {
	return &GetCorporationsCorporationIDMembersOK{}
}

/*GetCorporationsCorporationIDMembersOK handles this case with default header values.

List of member character IDs
*/
type GetCorporationsCorporationIDMembersOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetCorporationsCorporationIDMembersOKBodyItems0
}

func (o *GetCorporationsCorporationIDMembersOK) Error() string {
	return fmt.Sprintf("[GET /corporations/{corporation_id}/members/][%d] getCorporationsCorporationIdMembersOK  %+v", 200, o.Payload)
}

func (o *GetCorporationsCorporationIDMembersOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCorporationsCorporationIDMembersForbidden creates a GetCorporationsCorporationIDMembersForbidden with default headers values
func NewGetCorporationsCorporationIDMembersForbidden() *GetCorporationsCorporationIDMembersForbidden {
	return &GetCorporationsCorporationIDMembersForbidden{}
}

/*GetCorporationsCorporationIDMembersForbidden handles this case with default header values.

Forbidden
*/
type GetCorporationsCorporationIDMembersForbidden struct {
	Payload GetCorporationsCorporationIDMembersForbiddenBody
}

func (o *GetCorporationsCorporationIDMembersForbidden) Error() string {
	return fmt.Sprintf("[GET /corporations/{corporation_id}/members/][%d] getCorporationsCorporationIdMembersForbidden  %+v", 403, o.Payload)
}

func (o *GetCorporationsCorporationIDMembersForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCorporationsCorporationIDMembersInternalServerError creates a GetCorporationsCorporationIDMembersInternalServerError with default headers values
func NewGetCorporationsCorporationIDMembersInternalServerError() *GetCorporationsCorporationIDMembersInternalServerError {
	return &GetCorporationsCorporationIDMembersInternalServerError{}
}

/*GetCorporationsCorporationIDMembersInternalServerError handles this case with default header values.

Internal server error
*/
type GetCorporationsCorporationIDMembersInternalServerError struct {
	Payload GetCorporationsCorporationIDMembersInternalServerErrorBody
}

func (o *GetCorporationsCorporationIDMembersInternalServerError) Error() string {
	return fmt.Sprintf("[GET /corporations/{corporation_id}/members/][%d] getCorporationsCorporationIdMembersInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCorporationsCorporationIDMembersInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetCorporationsCorporationIDMembersInternalServerErrorBody get_corporations_corporation_id_members_internal_server_error
//
// Internal server error
swagger:model GetCorporationsCorporationIDMembersInternalServerErrorBody
*/
type GetCorporationsCorporationIDMembersInternalServerErrorBody struct {

	// get_corporations_corporation_id_members_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}

/*GetCorporationsCorporationIDMembersOKBodyItems0 get_corporations_corporation_id_members_200_ok
//
// 200 ok object
swagger:model GetCorporationsCorporationIDMembersOKBodyItems0
*/
type GetCorporationsCorporationIDMembersOKBodyItems0 struct {

	// get_corporations_corporation_id_members_character_id
	//
	// character_id integer
	// Required: true
	CharacterID *int32 `json:"character_id"`
}

/*GetCorporationsCorporationIDMembersForbiddenBody get_corporations_corporation_id_members_forbidden
//
// Forbidden
swagger:model GetCorporationsCorporationIDMembersForbiddenBody
*/
type GetCorporationsCorporationIDMembersForbiddenBody struct {

	// get_corporations_corporation_id_members_403_forbidden
	//
	// Forbidden message
	// Required: true
	Error *string `json:"error"`
}
