package corporation

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetCorporationsCorporationIDStructuresParams creates a new GetCorporationsCorporationIDStructuresParams object
// with the default values initialized.
func NewGetCorporationsCorporationIDStructuresParams() *GetCorporationsCorporationIDStructuresParams {
	var (
		datasourceDefault = string("tranquility")
		languageDefault   = string("en-us")
	)
	return &GetCorporationsCorporationIDStructuresParams{
		Datasource: &datasourceDefault,
		Language:   &languageDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetCorporationsCorporationIDStructuresParamsWithTimeout creates a new GetCorporationsCorporationIDStructuresParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetCorporationsCorporationIDStructuresParamsWithTimeout(timeout time.Duration) *GetCorporationsCorporationIDStructuresParams {
	var (
		datasourceDefault = string("tranquility")
		languageDefault   = string("en-us")
	)
	return &GetCorporationsCorporationIDStructuresParams{
		Datasource: &datasourceDefault,
		Language:   &languageDefault,

		timeout: timeout,
	}
}

// NewGetCorporationsCorporationIDStructuresParamsWithContext creates a new GetCorporationsCorporationIDStructuresParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetCorporationsCorporationIDStructuresParamsWithContext(ctx context.Context) *GetCorporationsCorporationIDStructuresParams {
	var (
		datasourceDefault = string("tranquility")
		languageDefault   = string("en-us")
	)
	return &GetCorporationsCorporationIDStructuresParams{
		Datasource: &datasourceDefault,
		Language:   &languageDefault,

		Context: ctx,
	}
}

/*GetCorporationsCorporationIDStructuresParams contains all the parameters to send to the API endpoint
for the get corporations corporation id structures operation typically these are written to a http.Request
*/
type GetCorporationsCorporationIDStructuresParams struct {

	/*XUserAgent
	  Client identifier, takes precedence over User-Agent

	*/
	XUserAgent *string
	/*CorporationID
	  A corporation ID

	*/
	CorporationID int32
	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*Language
	  Language to use in the response

	*/
	Language *string
	/*Page
	  Which page to query, 250 structures per page

	*/
	Page *int32
	/*Token
	  Access token to use, if preferred over a header

	*/
	Token *string
	/*UserAgent
	  Client identifier, takes precedence over headers

	*/
	UserAgent *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get corporations corporation id structures params
func (o *GetCorporationsCorporationIDStructuresParams) WithTimeout(timeout time.Duration) *GetCorporationsCorporationIDStructuresParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get corporations corporation id structures params
func (o *GetCorporationsCorporationIDStructuresParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get corporations corporation id structures params
func (o *GetCorporationsCorporationIDStructuresParams) WithContext(ctx context.Context) *GetCorporationsCorporationIDStructuresParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get corporations corporation id structures params
func (o *GetCorporationsCorporationIDStructuresParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithXUserAgent adds the xUserAgent to the get corporations corporation id structures params
func (o *GetCorporationsCorporationIDStructuresParams) WithXUserAgent(xUserAgent *string) *GetCorporationsCorporationIDStructuresParams {
	o.SetXUserAgent(xUserAgent)
	return o
}

// SetXUserAgent adds the xUserAgent to the get corporations corporation id structures params
func (o *GetCorporationsCorporationIDStructuresParams) SetXUserAgent(xUserAgent *string) {
	o.XUserAgent = xUserAgent
}

// WithCorporationID adds the corporationID to the get corporations corporation id structures params
func (o *GetCorporationsCorporationIDStructuresParams) WithCorporationID(corporationID int32) *GetCorporationsCorporationIDStructuresParams {
	o.SetCorporationID(corporationID)
	return o
}

// SetCorporationID adds the corporationId to the get corporations corporation id structures params
func (o *GetCorporationsCorporationIDStructuresParams) SetCorporationID(corporationID int32) {
	o.CorporationID = corporationID
}

// WithDatasource adds the datasource to the get corporations corporation id structures params
func (o *GetCorporationsCorporationIDStructuresParams) WithDatasource(datasource *string) *GetCorporationsCorporationIDStructuresParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the get corporations corporation id structures params
func (o *GetCorporationsCorporationIDStructuresParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithLanguage adds the language to the get corporations corporation id structures params
func (o *GetCorporationsCorporationIDStructuresParams) WithLanguage(language *string) *GetCorporationsCorporationIDStructuresParams {
	o.SetLanguage(language)
	return o
}

// SetLanguage adds the language to the get corporations corporation id structures params
func (o *GetCorporationsCorporationIDStructuresParams) SetLanguage(language *string) {
	o.Language = language
}

// WithPage adds the page to the get corporations corporation id structures params
func (o *GetCorporationsCorporationIDStructuresParams) WithPage(page *int32) *GetCorporationsCorporationIDStructuresParams {
	o.SetPage(page)
	return o
}

// SetPage adds the page to the get corporations corporation id structures params
func (o *GetCorporationsCorporationIDStructuresParams) SetPage(page *int32) {
	o.Page = page
}

// WithToken adds the token to the get corporations corporation id structures params
func (o *GetCorporationsCorporationIDStructuresParams) WithToken(token *string) *GetCorporationsCorporationIDStructuresParams {
	o.SetToken(token)
	return o
}

// SetToken adds the token to the get corporations corporation id structures params
func (o *GetCorporationsCorporationIDStructuresParams) SetToken(token *string) {
	o.Token = token
}

// WithUserAgent adds the userAgent to the get corporations corporation id structures params
func (o *GetCorporationsCorporationIDStructuresParams) WithUserAgent(userAgent *string) *GetCorporationsCorporationIDStructuresParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the get corporations corporation id structures params
func (o *GetCorporationsCorporationIDStructuresParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WriteToRequest writes these params to a swagger request
func (o *GetCorporationsCorporationIDStructuresParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	r.SetTimeout(o.timeout)
	var res []error

	if o.XUserAgent != nil {

		// header param X-User-Agent
		if err := r.SetHeaderParam("X-User-Agent", *o.XUserAgent); err != nil {
			return err
		}

	}

	// path param corporation_id
	if err := r.SetPathParam("corporation_id", swag.FormatInt32(o.CorporationID)); err != nil {
		return err
	}

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	if o.Language != nil {

		// query param language
		var qrLanguage string
		if o.Language != nil {
			qrLanguage = *o.Language
		}
		qLanguage := qrLanguage
		if qLanguage != "" {
			if err := r.SetQueryParam("language", qLanguage); err != nil {
				return err
			}
		}

	}

	if o.Page != nil {

		// query param page
		var qrPage int32
		if o.Page != nil {
			qrPage = *o.Page
		}
		qPage := swag.FormatInt32(qrPage)
		if qPage != "" {
			if err := r.SetQueryParam("page", qPage); err != nil {
				return err
			}
		}

	}

	if o.Token != nil {

		// query param token
		var qrToken string
		if o.Token != nil {
			qrToken = *o.Token
		}
		qToken := qrToken
		if qToken != "" {
			if err := r.SetQueryParam("token", qToken); err != nil {
				return err
			}
		}

	}

	if o.UserAgent != nil {

		// query param user_agent
		var qrUserAgent string
		if o.UserAgent != nil {
			qrUserAgent = *o.UserAgent
		}
		qUserAgent := qrUserAgent
		if qUserAgent != "" {
			if err := r.SetQueryParam("user_agent", qUserAgent); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
