package corporation

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// GetCorporationsCorporationIDStructuresReader is a Reader for the GetCorporationsCorporationIDStructures structure.
type GetCorporationsCorporationIDStructuresReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCorporationsCorporationIDStructuresReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetCorporationsCorporationIDStructuresOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewGetCorporationsCorporationIDStructuresForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetCorporationsCorporationIDStructuresInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCorporationsCorporationIDStructuresOK creates a GetCorporationsCorporationIDStructuresOK with default headers values
func NewGetCorporationsCorporationIDStructuresOK() *GetCorporationsCorporationIDStructuresOK {
	return &GetCorporationsCorporationIDStructuresOK{}
}

/*GetCorporationsCorporationIDStructuresOK handles this case with default header values.

List of corporation structures' information
*/
type GetCorporationsCorporationIDStructuresOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*The language used in the response
	 */
	ContentLanguage string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetCorporationsCorporationIDStructuresOKBodyItems0
}

func (o *GetCorporationsCorporationIDStructuresOK) Error() string {
	return fmt.Sprintf("[GET /corporations/{corporation_id}/structures/][%d] getCorporationsCorporationIdStructuresOK  %+v", 200, o.Payload)
}

func (o *GetCorporationsCorporationIDStructuresOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Content-Language
	o.ContentLanguage = response.GetHeader("Content-Language")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCorporationsCorporationIDStructuresForbidden creates a GetCorporationsCorporationIDStructuresForbidden with default headers values
func NewGetCorporationsCorporationIDStructuresForbidden() *GetCorporationsCorporationIDStructuresForbidden {
	return &GetCorporationsCorporationIDStructuresForbidden{}
}

/*GetCorporationsCorporationIDStructuresForbidden handles this case with default header values.

Forbidden
*/
type GetCorporationsCorporationIDStructuresForbidden struct {
	Payload GetCorporationsCorporationIDStructuresForbiddenBody
}

func (o *GetCorporationsCorporationIDStructuresForbidden) Error() string {
	return fmt.Sprintf("[GET /corporations/{corporation_id}/structures/][%d] getCorporationsCorporationIdStructuresForbidden  %+v", 403, o.Payload)
}

func (o *GetCorporationsCorporationIDStructuresForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCorporationsCorporationIDStructuresInternalServerError creates a GetCorporationsCorporationIDStructuresInternalServerError with default headers values
func NewGetCorporationsCorporationIDStructuresInternalServerError() *GetCorporationsCorporationIDStructuresInternalServerError {
	return &GetCorporationsCorporationIDStructuresInternalServerError{}
}

/*GetCorporationsCorporationIDStructuresInternalServerError handles this case with default header values.

Internal server error
*/
type GetCorporationsCorporationIDStructuresInternalServerError struct {
	Payload GetCorporationsCorporationIDStructuresInternalServerErrorBody
}

func (o *GetCorporationsCorporationIDStructuresInternalServerError) Error() string {
	return fmt.Sprintf("[GET /corporations/{corporation_id}/structures/][%d] getCorporationsCorporationIdStructuresInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCorporationsCorporationIDStructuresInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetCorporationsCorporationIDStructuresOKBodyItems0NextVulItems0 get_corporations_corporation_id_structures_next_vul
//
// next_vul object
swagger:model GetCorporationsCorporationIDStructuresOKBodyItems0NextVulItems0
*/
type GetCorporationsCorporationIDStructuresOKBodyItems0NextVulItems0 struct {

	// get_corporations_corporation_id_structures_day
	//
	// day integer
	// Required: true
	Day *int32 `json:"day"`

	// get_corporations_corporation_id_structures_hour
	//
	// hour integer
	// Required: true
	Hour *int32 `json:"hour"`
}

/*GetCorporationsCorporationIDStructuresOKBodyItems0CurrentVulItems0 get_corporations_corporation_id_structures_current_vul
//
// current_vul object
swagger:model GetCorporationsCorporationIDStructuresOKBodyItems0CurrentVulItems0
*/
type GetCorporationsCorporationIDStructuresOKBodyItems0CurrentVulItems0 struct {

	// get_corporations_corporation_id_structures_day
	//
	// day integer
	// Required: true
	Day *int32 `json:"day"`

	// get_corporations_corporation_id_structures_hour
	//
	// hour integer
	// Required: true
	Hour *int32 `json:"hour"`
}

/*GetCorporationsCorporationIDStructuresOKBodyItems0 get_corporations_corporation_id_structures_200_ok
//
// 200 ok object
swagger:model GetCorporationsCorporationIDStructuresOKBodyItems0
*/
type GetCorporationsCorporationIDStructuresOKBodyItems0 struct {

	// get_corporations_corporation_id_structures_corporation_id
	//
	// ID of the corporation that owns the structure
	// Required: true
	CorporationID *int32 `json:"corporation_id"`

	// get_corporations_corporation_id_structures_current_vul
	//
	// This week's vulnerability windows, Monday is day 0
	// Required: true
	CurrentVul []*GetCorporationsCorporationIDStructuresOKBodyItems0CurrentVulItems0 `json:"current_vul"`

	// get_corporations_corporation_id_structures_fuel_expires
	//
	// Date on which the structure will run out of fuel
	FuelExpires strfmt.Date `json:"fuel_expires,omitempty"`

	// get_corporations_corporation_id_structures_next_vul
	//
	// Next week's vulnerability windows, Monday is day 0
	// Required: true
	NextVul []*GetCorporationsCorporationIDStructuresOKBodyItems0NextVulItems0 `json:"next_vul"`

	// get_corporations_corporation_id_structures_profile_id
	//
	// The id of the ACL profile for this citadel
	// Required: true
	ProfileID *int32 `json:"profile_id"`

	// get_corporations_corporation_id_structures_services
	//
	// Contains a list of service upgrades, and their state
	Services []*GetCorporationsCorporationIDStructuresOKBodyItems0ServicesItems0 `json:"services"`

	// get_corporations_corporation_id_structures_state_timer_end
	//
	// Date at which the structure will move to it's next state
	StateTimerEnd strfmt.Date `json:"state_timer_end,omitempty"`

	// get_corporations_corporation_id_structures_state_timer_start
	//
	// Date at which the structure entered it's current state
	StateTimerStart strfmt.Date `json:"state_timer_start,omitempty"`

	// get_corporations_corporation_id_structures_structure_id
	//
	// The Item ID of the structure
	// Required: true
	StructureID *int64 `json:"structure_id"`

	// get_corporations_corporation_id_structures_system_id
	//
	// The solar system the structure is in
	// Required: true
	SystemID *int32 `json:"system_id"`

	// get_corporations_corporation_id_structures_type_id
	//
	// The type id of the structure
	// Required: true
	TypeID *int32 `json:"type_id"`

	// get_corporations_corporation_id_structures_unanchors_at
	//
	// Date at which the structure will unanchor
	UnanchorsAt strfmt.Date `json:"unanchors_at,omitempty"`
}

/*GetCorporationsCorporationIDStructuresForbiddenBody get_corporations_corporation_id_structures_forbidden
//
// Forbidden
swagger:model GetCorporationsCorporationIDStructuresForbiddenBody
*/
type GetCorporationsCorporationIDStructuresForbiddenBody struct {

	// get_corporations_corporation_id_structures_403_forbidden
	//
	// Forbidden message
	// Required: true
	Error *string `json:"error"`
}

/*GetCorporationsCorporationIDStructuresInternalServerErrorBody get_corporations_corporation_id_structures_internal_server_error
//
// Internal server error
swagger:model GetCorporationsCorporationIDStructuresInternalServerErrorBody
*/
type GetCorporationsCorporationIDStructuresInternalServerErrorBody struct {

	// get_corporations_corporation_id_structures_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}

/*GetCorporationsCorporationIDStructuresOKBodyItems0ServicesItems0 get_corporations_corporation_id_structures_service
//
// service object
swagger:model GetCorporationsCorporationIDStructuresOKBodyItems0ServicesItems0
*/
type GetCorporationsCorporationIDStructuresOKBodyItems0ServicesItems0 struct {

	// get_corporations_corporation_id_structures_name
	//
	// name string
	// Required: true
	Name *string `json:"name"`

	// get_corporations_corporation_id_structures_state
	//
	// state string
	// Required: true
	State *string `json:"state"`
}
