package corporation

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// GetCorporationsNamesReader is a Reader for the GetCorporationsNames structure.
type GetCorporationsNamesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCorporationsNamesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetCorporationsNamesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 500:
		result := NewGetCorporationsNamesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCorporationsNamesOK creates a GetCorporationsNamesOK with default headers values
func NewGetCorporationsNamesOK() *GetCorporationsNamesOK {
	return &GetCorporationsNamesOK{}
}

/*GetCorporationsNamesOK handles this case with default header values.

List of id/name associations
*/
type GetCorporationsNamesOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetCorporationsNamesOKBodyItems0
}

func (o *GetCorporationsNamesOK) Error() string {
	return fmt.Sprintf("[GET /corporations/names/][%d] getCorporationsNamesOK  %+v", 200, o.Payload)
}

func (o *GetCorporationsNamesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCorporationsNamesInternalServerError creates a GetCorporationsNamesInternalServerError with default headers values
func NewGetCorporationsNamesInternalServerError() *GetCorporationsNamesInternalServerError {
	return &GetCorporationsNamesInternalServerError{}
}

/*GetCorporationsNamesInternalServerError handles this case with default header values.

Internal server error
*/
type GetCorporationsNamesInternalServerError struct {
	Payload GetCorporationsNamesInternalServerErrorBody
}

func (o *GetCorporationsNamesInternalServerError) Error() string {
	return fmt.Sprintf("[GET /corporations/names/][%d] getCorporationsNamesInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCorporationsNamesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetCorporationsNamesInternalServerErrorBody get_corporations_names_internal_server_error
//
// Internal server error
swagger:model GetCorporationsNamesInternalServerErrorBody
*/
type GetCorporationsNamesInternalServerErrorBody struct {

	// get_corporations_names_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}

/*GetCorporationsNamesOKBodyItems0 get_corporations_names_200_ok
//
// 200 ok object
swagger:model GetCorporationsNamesOKBodyItems0
*/
type GetCorporationsNamesOKBodyItems0 struct {

	// get_corporations_names_corporation_id
	//
	// corporation_id integer
	// Required: true
	CorporationID *int32 `json:"corporation_id"`

	// get_corporations_names_corporation_name
	//
	// corporation_name string
	// Required: true
	CorporationName *string `json:"corporation_name"`
}
