package dogma

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// GetDogmaAttributesReader is a Reader for the GetDogmaAttributes structure.
type GetDogmaAttributesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDogmaAttributesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetDogmaAttributesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 500:
		result := NewGetDogmaAttributesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetDogmaAttributesOK creates a GetDogmaAttributesOK with default headers values
func NewGetDogmaAttributesOK() *GetDogmaAttributesOK {
	return &GetDogmaAttributesOK{}
}

/*GetDogmaAttributesOK handles this case with default header values.

A list of dogma attribute ids
*/
type GetDogmaAttributesOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []int32
}

func (o *GetDogmaAttributesOK) Error() string {
	return fmt.Sprintf("[GET /dogma/attributes/][%d] getDogmaAttributesOK  %+v", 200, o.Payload)
}

func (o *GetDogmaAttributesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDogmaAttributesInternalServerError creates a GetDogmaAttributesInternalServerError with default headers values
func NewGetDogmaAttributesInternalServerError() *GetDogmaAttributesInternalServerError {
	return &GetDogmaAttributesInternalServerError{}
}

/*GetDogmaAttributesInternalServerError handles this case with default header values.

Internal server error
*/
type GetDogmaAttributesInternalServerError struct {
	Payload GetDogmaAttributesInternalServerErrorBody
}

func (o *GetDogmaAttributesInternalServerError) Error() string {
	return fmt.Sprintf("[GET /dogma/attributes/][%d] getDogmaAttributesInternalServerError  %+v", 500, o.Payload)
}

func (o *GetDogmaAttributesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetDogmaAttributesInternalServerErrorBody get_dogma_attributes_internal_server_error
//
// Internal server error
swagger:model GetDogmaAttributesInternalServerErrorBody
*/
type GetDogmaAttributesInternalServerErrorBody struct {

	// get_dogma_attributes_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}
