package dogma

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetDogmaEffectsEffectIDParams creates a new GetDogmaEffectsEffectIDParams object
// with the default values initialized.
func NewGetDogmaEffectsEffectIDParams() *GetDogmaEffectsEffectIDParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetDogmaEffectsEffectIDParams{
		Datasource: &datasourceDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetDogmaEffectsEffectIDParamsWithTimeout creates a new GetDogmaEffectsEffectIDParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetDogmaEffectsEffectIDParamsWithTimeout(timeout time.Duration) *GetDogmaEffectsEffectIDParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetDogmaEffectsEffectIDParams{
		Datasource: &datasourceDefault,

		timeout: timeout,
	}
}

// NewGetDogmaEffectsEffectIDParamsWithContext creates a new GetDogmaEffectsEffectIDParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetDogmaEffectsEffectIDParamsWithContext(ctx context.Context) *GetDogmaEffectsEffectIDParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetDogmaEffectsEffectIDParams{
		Datasource: &datasourceDefault,

		Context: ctx,
	}
}

/*GetDogmaEffectsEffectIDParams contains all the parameters to send to the API endpoint
for the get dogma effects effect id operation typically these are written to a http.Request
*/
type GetDogmaEffectsEffectIDParams struct {

	/*XUserAgent
	  Client identifier, takes precedence over User-Agent

	*/
	XUserAgent *string
	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*EffectID
	  A dogma effect ID

	*/
	EffectID int32
	/*UserAgent
	  Client identifier, takes precedence over headers

	*/
	UserAgent *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get dogma effects effect id params
func (o *GetDogmaEffectsEffectIDParams) WithTimeout(timeout time.Duration) *GetDogmaEffectsEffectIDParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get dogma effects effect id params
func (o *GetDogmaEffectsEffectIDParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get dogma effects effect id params
func (o *GetDogmaEffectsEffectIDParams) WithContext(ctx context.Context) *GetDogmaEffectsEffectIDParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get dogma effects effect id params
func (o *GetDogmaEffectsEffectIDParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithXUserAgent adds the xUserAgent to the get dogma effects effect id params
func (o *GetDogmaEffectsEffectIDParams) WithXUserAgent(xUserAgent *string) *GetDogmaEffectsEffectIDParams {
	o.SetXUserAgent(xUserAgent)
	return o
}

// SetXUserAgent adds the xUserAgent to the get dogma effects effect id params
func (o *GetDogmaEffectsEffectIDParams) SetXUserAgent(xUserAgent *string) {
	o.XUserAgent = xUserAgent
}

// WithDatasource adds the datasource to the get dogma effects effect id params
func (o *GetDogmaEffectsEffectIDParams) WithDatasource(datasource *string) *GetDogmaEffectsEffectIDParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the get dogma effects effect id params
func (o *GetDogmaEffectsEffectIDParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithEffectID adds the effectID to the get dogma effects effect id params
func (o *GetDogmaEffectsEffectIDParams) WithEffectID(effectID int32) *GetDogmaEffectsEffectIDParams {
	o.SetEffectID(effectID)
	return o
}

// SetEffectID adds the effectId to the get dogma effects effect id params
func (o *GetDogmaEffectsEffectIDParams) SetEffectID(effectID int32) {
	o.EffectID = effectID
}

// WithUserAgent adds the userAgent to the get dogma effects effect id params
func (o *GetDogmaEffectsEffectIDParams) WithUserAgent(userAgent *string) *GetDogmaEffectsEffectIDParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the get dogma effects effect id params
func (o *GetDogmaEffectsEffectIDParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WriteToRequest writes these params to a swagger request
func (o *GetDogmaEffectsEffectIDParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	r.SetTimeout(o.timeout)
	var res []error

	if o.XUserAgent != nil {

		// header param X-User-Agent
		if err := r.SetHeaderParam("X-User-Agent", *o.XUserAgent); err != nil {
			return err
		}

	}

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	// path param effect_id
	if err := r.SetPathParam("effect_id", swag.FormatInt32(o.EffectID)); err != nil {
		return err
	}

	if o.UserAgent != nil {

		// query param user_agent
		var qrUserAgent string
		if o.UserAgent != nil {
			qrUserAgent = *o.UserAgent
		}
		qUserAgent := qrUserAgent
		if qUserAgent != "" {
			if err := r.SetQueryParam("user_agent", qUserAgent); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
