package dogma

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// GetDogmaEffectsEffectIDReader is a Reader for the GetDogmaEffectsEffectID structure.
type GetDogmaEffectsEffectIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDogmaEffectsEffectIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetDogmaEffectsEffectIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 404:
		result := NewGetDogmaEffectsEffectIDNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetDogmaEffectsEffectIDInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetDogmaEffectsEffectIDOK creates a GetDogmaEffectsEffectIDOK with default headers values
func NewGetDogmaEffectsEffectIDOK() *GetDogmaEffectsEffectIDOK {
	return &GetDogmaEffectsEffectIDOK{}
}

/*GetDogmaEffectsEffectIDOK handles this case with default header values.

Information about a dogma effect
*/
type GetDogmaEffectsEffectIDOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload GetDogmaEffectsEffectIDOKBody
}

func (o *GetDogmaEffectsEffectIDOK) Error() string {
	return fmt.Sprintf("[GET /dogma/effects/{effect_id}/][%d] getDogmaEffectsEffectIdOK  %+v", 200, o.Payload)
}

func (o *GetDogmaEffectsEffectIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDogmaEffectsEffectIDNotFound creates a GetDogmaEffectsEffectIDNotFound with default headers values
func NewGetDogmaEffectsEffectIDNotFound() *GetDogmaEffectsEffectIDNotFound {
	return &GetDogmaEffectsEffectIDNotFound{}
}

/*GetDogmaEffectsEffectIDNotFound handles this case with default header values.

Dogma effect not found
*/
type GetDogmaEffectsEffectIDNotFound struct {
	Payload GetDogmaEffectsEffectIDNotFoundBody
}

func (o *GetDogmaEffectsEffectIDNotFound) Error() string {
	return fmt.Sprintf("[GET /dogma/effects/{effect_id}/][%d] getDogmaEffectsEffectIdNotFound  %+v", 404, o.Payload)
}

func (o *GetDogmaEffectsEffectIDNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDogmaEffectsEffectIDInternalServerError creates a GetDogmaEffectsEffectIDInternalServerError with default headers values
func NewGetDogmaEffectsEffectIDInternalServerError() *GetDogmaEffectsEffectIDInternalServerError {
	return &GetDogmaEffectsEffectIDInternalServerError{}
}

/*GetDogmaEffectsEffectIDInternalServerError handles this case with default header values.

Internal server error
*/
type GetDogmaEffectsEffectIDInternalServerError struct {
	Payload GetDogmaEffectsEffectIDInternalServerErrorBody
}

func (o *GetDogmaEffectsEffectIDInternalServerError) Error() string {
	return fmt.Sprintf("[GET /dogma/effects/{effect_id}/][%d] getDogmaEffectsEffectIdInternalServerError  %+v", 500, o.Payload)
}

func (o *GetDogmaEffectsEffectIDInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*ModifiersItems0 get_dogma_effects_effect_id_modifier
//
// modifier object
swagger:model ModifiersItems0
*/
type ModifiersItems0 struct {

	// get_dogma_effects_effect_id_domain
	//
	// domain string
	// Required: true
	Domain *string `json:"domain"`

	// get_dogma_effects_effect_id_func
	//
	// func string
	// Required: true
	Func *string `json:"func"`

	// get_dogma_effects_effect_id_modified_attribute_id
	//
	// modified_attribute_id integer
	// Required: true
	ModifiedAttributeID *int32 `json:"modified_attribute_id"`

	// get_dogma_effects_effect_id_modifying_attribute_id
	//
	// modifying_attribute_id integer
	// Required: true
	ModifyingAttributeID *int32 `json:"modifying_attribute_id"`

	// get_dogma_effects_effect_id_operator
	//
	// operator integer
	// Required: true
	Operator *int32 `json:"operator"`
}

/*GetDogmaEffectsEffectIDOKBody get_dogma_effects_effect_id_ok
//
// 200 ok object
swagger:model GetDogmaEffectsEffectIDOKBody
*/
type GetDogmaEffectsEffectIDOKBody struct {

	// get_dogma_effects_effect_id_description
	//
	// description string
	// Required: true
	Description *string `json:"description"`

	// get_dogma_effects_effect_id_disallow_auto_repeat
	//
	// disallow_auto_repeat boolean
	// Required: true
	DisallowAutoRepeat *bool `json:"disallow_auto_repeat"`

	// get_dogma_effects_effect_id_discharge_attribute_id
	//
	// discharge_attribute_id integer
	// Required: true
	DischargeAttributeID *int32 `json:"discharge_attribute_id"`

	// get_dogma_effects_effect_id_display_name
	//
	// display_name string
	// Required: true
	DisplayName *string `json:"display_name"`

	// get_dogma_effects_effect_id_duration_attribute_id
	//
	// duration_attribute_id integer
	// Required: true
	DurationAttributeID *int32 `json:"duration_attribute_id"`

	// get_dogma_effects_effect_id_effect_category
	//
	// effect_category integer
	// Required: true
	EffectCategory *int32 `json:"effect_category"`

	// get_dogma_effects_effect_id_effect_id
	//
	// effect_id integer
	// Required: true
	EffectID *int32 `json:"effect_id"`

	// get_dogma_effects_effect_id_electronic_chance
	//
	// electronic_chance boolean
	// Required: true
	ElectronicChance *bool `json:"electronic_chance"`

	// get_dogma_effects_effect_id_falloff_attribute_id
	//
	// falloff_attribute_id integer
	// Required: true
	FalloffAttributeID *int32 `json:"falloff_attribute_id"`

	// get_dogma_effects_effect_id_icon_id
	//
	// icon_id integer
	// Required: true
	IconID *int32 `json:"icon_id"`

	// get_dogma_effects_effect_id_is_assistance
	//
	// is_assistance boolean
	// Required: true
	IsAssistance *bool `json:"is_assistance"`

	// get_dogma_effects_effect_id_is_offensive
	//
	// is_offensive boolean
	// Required: true
	IsOffensive *bool `json:"is_offensive"`

	// get_dogma_effects_effect_id_is_warp_safe
	//
	// is_warp_safe boolean
	// Required: true
	IsWarpSafe *bool `json:"is_warp_safe"`

	// get_dogma_effects_effect_id_modifiers
	//
	// modifiers array
	// Required: true
	Modifiers []*ModifiersItems0 `json:"modifiers"`

	// get_dogma_effects_effect_id_name
	//
	// name string
	// Required: true
	Name *string `json:"name"`

	// get_dogma_effects_effect_id_post_expression
	//
	// post_expression integer
	// Required: true
	PostExpression *int32 `json:"post_expression"`

	// get_dogma_effects_effect_id_pre_expression
	//
	// pre_expression integer
	// Required: true
	PreExpression *int32 `json:"pre_expression"`

	// get_dogma_effects_effect_id_published
	//
	// published boolean
	// Required: true
	Published *bool `json:"published"`

	// get_dogma_effects_effect_id_range_attribute_id
	//
	// range_attribute_id integer
	// Required: true
	RangeAttributeID *int32 `json:"range_attribute_id"`

	// get_dogma_effects_effect_id_range_chance
	//
	// range_chance boolean
	// Required: true
	RangeChance *bool `json:"range_chance"`

	// get_dogma_effects_effect_id_tracking_speed_attribute_id
	//
	// tracking_speed_attribute_id integer
	// Required: true
	TrackingSpeedAttributeID *int32 `json:"tracking_speed_attribute_id"`
}

/*GetDogmaEffectsEffectIDNotFoundBody get_dogma_effects_effect_id_not_found
//
// Not found
swagger:model GetDogmaEffectsEffectIDNotFoundBody
*/
type GetDogmaEffectsEffectIDNotFoundBody struct {

	// get_dogma_effects_effect_id_404_not_found
	//
	// Not found message
	// Required: true
	Error *string `json:"error"`
}

/*GetDogmaEffectsEffectIDInternalServerErrorBody get_dogma_effects_effect_id_internal_server_error
//
// Internal server error
swagger:model GetDogmaEffectsEffectIDInternalServerErrorBody
*/
type GetDogmaEffectsEffectIDInternalServerErrorBody struct {

	// get_dogma_effects_effect_id_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}
