package fleets

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewDeleteFleetsFleetIDSquadsSquadIDParams creates a new DeleteFleetsFleetIDSquadsSquadIDParams object
// with the default values initialized.
func NewDeleteFleetsFleetIDSquadsSquadIDParams() *DeleteFleetsFleetIDSquadsSquadIDParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &DeleteFleetsFleetIDSquadsSquadIDParams{
		Datasource: &datasourceDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteFleetsFleetIDSquadsSquadIDParamsWithTimeout creates a new DeleteFleetsFleetIDSquadsSquadIDParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewDeleteFleetsFleetIDSquadsSquadIDParamsWithTimeout(timeout time.Duration) *DeleteFleetsFleetIDSquadsSquadIDParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &DeleteFleetsFleetIDSquadsSquadIDParams{
		Datasource: &datasourceDefault,

		timeout: timeout,
	}
}

// NewDeleteFleetsFleetIDSquadsSquadIDParamsWithContext creates a new DeleteFleetsFleetIDSquadsSquadIDParams object
// with the default values initialized, and the ability to set a context for a request
func NewDeleteFleetsFleetIDSquadsSquadIDParamsWithContext(ctx context.Context) *DeleteFleetsFleetIDSquadsSquadIDParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &DeleteFleetsFleetIDSquadsSquadIDParams{
		Datasource: &datasourceDefault,

		Context: ctx,
	}
}

/*DeleteFleetsFleetIDSquadsSquadIDParams contains all the parameters to send to the API endpoint
for the delete fleets fleet id squads squad id operation typically these are written to a http.Request
*/
type DeleteFleetsFleetIDSquadsSquadIDParams struct {

	/*XUserAgent
	  Client identifier, takes precedence over User-Agent

	*/
	XUserAgent *string
	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*FleetID
	  ID for a fleet

	*/
	FleetID int64
	/*SquadID
	  The squad to delete

	*/
	SquadID int64
	/*Token
	  Access token to use, if preferred over a header

	*/
	Token *string
	/*UserAgent
	  Client identifier, takes precedence over headers

	*/
	UserAgent *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the delete fleets fleet id squads squad id params
func (o *DeleteFleetsFleetIDSquadsSquadIDParams) WithTimeout(timeout time.Duration) *DeleteFleetsFleetIDSquadsSquadIDParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete fleets fleet id squads squad id params
func (o *DeleteFleetsFleetIDSquadsSquadIDParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete fleets fleet id squads squad id params
func (o *DeleteFleetsFleetIDSquadsSquadIDParams) WithContext(ctx context.Context) *DeleteFleetsFleetIDSquadsSquadIDParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete fleets fleet id squads squad id params
func (o *DeleteFleetsFleetIDSquadsSquadIDParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithXUserAgent adds the xUserAgent to the delete fleets fleet id squads squad id params
func (o *DeleteFleetsFleetIDSquadsSquadIDParams) WithXUserAgent(xUserAgent *string) *DeleteFleetsFleetIDSquadsSquadIDParams {
	o.SetXUserAgent(xUserAgent)
	return o
}

// SetXUserAgent adds the xUserAgent to the delete fleets fleet id squads squad id params
func (o *DeleteFleetsFleetIDSquadsSquadIDParams) SetXUserAgent(xUserAgent *string) {
	o.XUserAgent = xUserAgent
}

// WithDatasource adds the datasource to the delete fleets fleet id squads squad id params
func (o *DeleteFleetsFleetIDSquadsSquadIDParams) WithDatasource(datasource *string) *DeleteFleetsFleetIDSquadsSquadIDParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the delete fleets fleet id squads squad id params
func (o *DeleteFleetsFleetIDSquadsSquadIDParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithFleetID adds the fleetID to the delete fleets fleet id squads squad id params
func (o *DeleteFleetsFleetIDSquadsSquadIDParams) WithFleetID(fleetID int64) *DeleteFleetsFleetIDSquadsSquadIDParams {
	o.SetFleetID(fleetID)
	return o
}

// SetFleetID adds the fleetId to the delete fleets fleet id squads squad id params
func (o *DeleteFleetsFleetIDSquadsSquadIDParams) SetFleetID(fleetID int64) {
	o.FleetID = fleetID
}

// WithSquadID adds the squadID to the delete fleets fleet id squads squad id params
func (o *DeleteFleetsFleetIDSquadsSquadIDParams) WithSquadID(squadID int64) *DeleteFleetsFleetIDSquadsSquadIDParams {
	o.SetSquadID(squadID)
	return o
}

// SetSquadID adds the squadId to the delete fleets fleet id squads squad id params
func (o *DeleteFleetsFleetIDSquadsSquadIDParams) SetSquadID(squadID int64) {
	o.SquadID = squadID
}

// WithToken adds the token to the delete fleets fleet id squads squad id params
func (o *DeleteFleetsFleetIDSquadsSquadIDParams) WithToken(token *string) *DeleteFleetsFleetIDSquadsSquadIDParams {
	o.SetToken(token)
	return o
}

// SetToken adds the token to the delete fleets fleet id squads squad id params
func (o *DeleteFleetsFleetIDSquadsSquadIDParams) SetToken(token *string) {
	o.Token = token
}

// WithUserAgent adds the userAgent to the delete fleets fleet id squads squad id params
func (o *DeleteFleetsFleetIDSquadsSquadIDParams) WithUserAgent(userAgent *string) *DeleteFleetsFleetIDSquadsSquadIDParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the delete fleets fleet id squads squad id params
func (o *DeleteFleetsFleetIDSquadsSquadIDParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteFleetsFleetIDSquadsSquadIDParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	r.SetTimeout(o.timeout)
	var res []error

	if o.XUserAgent != nil {

		// header param X-User-Agent
		if err := r.SetHeaderParam("X-User-Agent", *o.XUserAgent); err != nil {
			return err
		}

	}

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	// path param fleet_id
	if err := r.SetPathParam("fleet_id", swag.FormatInt64(o.FleetID)); err != nil {
		return err
	}

	// path param squad_id
	if err := r.SetPathParam("squad_id", swag.FormatInt64(o.SquadID)); err != nil {
		return err
	}

	if o.Token != nil {

		// query param token
		var qrToken string
		if o.Token != nil {
			qrToken = *o.Token
		}
		qToken := qrToken
		if qToken != "" {
			if err := r.SetQueryParam("token", qToken); err != nil {
				return err
			}
		}

	}

	if o.UserAgent != nil {

		// query param user_agent
		var qrUserAgent string
		if o.UserAgent != nil {
			qrUserAgent = *o.UserAgent
		}
		qUserAgent := qrUserAgent
		if qUserAgent != "" {
			if err := r.SetQueryParam("user_agent", qUserAgent); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
