package fleets

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// GetFleetsFleetIDMembersReader is a Reader for the GetFleetsFleetIDMembers structure.
type GetFleetsFleetIDMembersReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetFleetsFleetIDMembersReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetFleetsFleetIDMembersOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewGetFleetsFleetIDMembersForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 404:
		result := NewGetFleetsFleetIDMembersNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetFleetsFleetIDMembersInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetFleetsFleetIDMembersOK creates a GetFleetsFleetIDMembersOK with default headers values
func NewGetFleetsFleetIDMembersOK() *GetFleetsFleetIDMembersOK {
	return &GetFleetsFleetIDMembersOK{}
}

/*GetFleetsFleetIDMembersOK handles this case with default header values.

A list of fleet members
*/
type GetFleetsFleetIDMembersOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*The language used in the response
	 */
	ContentLanguage string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetFleetsFleetIDMembersOKBodyItems0
}

func (o *GetFleetsFleetIDMembersOK) Error() string {
	return fmt.Sprintf("[GET /fleets/{fleet_id}/members/][%d] getFleetsFleetIdMembersOK  %+v", 200, o.Payload)
}

func (o *GetFleetsFleetIDMembersOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Content-Language
	o.ContentLanguage = response.GetHeader("Content-Language")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetFleetsFleetIDMembersForbidden creates a GetFleetsFleetIDMembersForbidden with default headers values
func NewGetFleetsFleetIDMembersForbidden() *GetFleetsFleetIDMembersForbidden {
	return &GetFleetsFleetIDMembersForbidden{}
}

/*GetFleetsFleetIDMembersForbidden handles this case with default header values.

Forbidden
*/
type GetFleetsFleetIDMembersForbidden struct {
	Payload GetFleetsFleetIDMembersForbiddenBody
}

func (o *GetFleetsFleetIDMembersForbidden) Error() string {
	return fmt.Sprintf("[GET /fleets/{fleet_id}/members/][%d] getFleetsFleetIdMembersForbidden  %+v", 403, o.Payload)
}

func (o *GetFleetsFleetIDMembersForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetFleetsFleetIDMembersNotFound creates a GetFleetsFleetIDMembersNotFound with default headers values
func NewGetFleetsFleetIDMembersNotFound() *GetFleetsFleetIDMembersNotFound {
	return &GetFleetsFleetIDMembersNotFound{}
}

/*GetFleetsFleetIDMembersNotFound handles this case with default header values.

The fleet does not exist or you don't have access to it
*/
type GetFleetsFleetIDMembersNotFound struct {
	Payload GetFleetsFleetIDMembersNotFoundBody
}

func (o *GetFleetsFleetIDMembersNotFound) Error() string {
	return fmt.Sprintf("[GET /fleets/{fleet_id}/members/][%d] getFleetsFleetIdMembersNotFound  %+v", 404, o.Payload)
}

func (o *GetFleetsFleetIDMembersNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetFleetsFleetIDMembersInternalServerError creates a GetFleetsFleetIDMembersInternalServerError with default headers values
func NewGetFleetsFleetIDMembersInternalServerError() *GetFleetsFleetIDMembersInternalServerError {
	return &GetFleetsFleetIDMembersInternalServerError{}
}

/*GetFleetsFleetIDMembersInternalServerError handles this case with default header values.

Internal server error
*/
type GetFleetsFleetIDMembersInternalServerError struct {
	Payload GetFleetsFleetIDMembersInternalServerErrorBody
}

func (o *GetFleetsFleetIDMembersInternalServerError) Error() string {
	return fmt.Sprintf("[GET /fleets/{fleet_id}/members/][%d] getFleetsFleetIdMembersInternalServerError  %+v", 500, o.Payload)
}

func (o *GetFleetsFleetIDMembersInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetFleetsFleetIDMembersOKBodyItems0 get_fleets_fleet_id_members_200_ok
//
// 200 ok object
swagger:model GetFleetsFleetIDMembersOKBodyItems0
*/
type GetFleetsFleetIDMembersOKBodyItems0 struct {

	// get_fleets_fleet_id_members_character_id
	//
	// character_id integer
	// Required: true
	CharacterID *int32 `json:"character_id"`

	// get_fleets_fleet_id_members_join_time
	//
	// join_time string
	// Required: true
	JoinTime *strfmt.DateTime `json:"join_time"`

	// get_fleets_fleet_id_members_role
	//
	// Member’s role in fleet
	// Required: true
	Role *string `json:"role"`

	// get_fleets_fleet_id_members_role_name
	//
	// Localized role names
	// Required: true
	RoleName *string `json:"role_name"`

	// get_fleets_fleet_id_members_ship_type_id
	//
	// ship_type_id integer
	// Required: true
	ShipTypeID *int32 `json:"ship_type_id"`

	// get_fleets_fleet_id_members_solar_system_id
	//
	// Solar system the member is located in
	// Required: true
	SolarSystemID *int32 `json:"solar_system_id"`

	// get_fleets_fleet_id_members_squad_id
	//
	// ID of the squad the member is in. If not applicable, will be set to -1
	// Required: true
	SquadID *int64 `json:"squad_id"`

	// get_fleets_fleet_id_members_station_id
	//
	// Station in which the member is docked in, if applicable
	StationID int64 `json:"station_id,omitempty"`

	// get_fleets_fleet_id_members_takes_fleet_warp
	//
	// Whether the member take fleet warps
	// Required: true
	TakesFleetWarp *bool `json:"takes_fleet_warp"`

	// get_fleets_fleet_id_members_wing_id
	//
	// ID of the wing the member is in. If not applicable, will be set to -1
	// Required: true
	WingID *int64 `json:"wing_id"`
}

/*GetFleetsFleetIDMembersForbiddenBody get_fleets_fleet_id_members_forbidden
//
// Forbidden
swagger:model GetFleetsFleetIDMembersForbiddenBody
*/
type GetFleetsFleetIDMembersForbiddenBody struct {

	// get_fleets_fleet_id_members_403_forbidden
	//
	// Forbidden message
	// Required: true
	Error *string `json:"error"`
}

/*GetFleetsFleetIDMembersNotFoundBody get_fleets_fleet_id_members_not_found
//
// Not found
swagger:model GetFleetsFleetIDMembersNotFoundBody
*/
type GetFleetsFleetIDMembersNotFoundBody struct {

	// get_fleets_fleet_id_members_404_not_found
	//
	// Not found message
	// Required: true
	Error *string `json:"error"`
}

/*GetFleetsFleetIDMembersInternalServerErrorBody get_fleets_fleet_id_members_internal_server_error
//
// Internal server error
swagger:model GetFleetsFleetIDMembersInternalServerErrorBody
*/
type GetFleetsFleetIDMembersInternalServerErrorBody struct {

	// get_fleets_fleet_id_members_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}
