package fleets

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetFleetsFleetIDWingsParams creates a new GetFleetsFleetIDWingsParams object
// with the default values initialized.
func NewGetFleetsFleetIDWingsParams() *GetFleetsFleetIDWingsParams {
	var (
		datasourceDefault = string("tranquility")
		languageDefault   = string("en-us")
	)
	return &GetFleetsFleetIDWingsParams{
		Datasource: &datasourceDefault,
		Language:   &languageDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetFleetsFleetIDWingsParamsWithTimeout creates a new GetFleetsFleetIDWingsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetFleetsFleetIDWingsParamsWithTimeout(timeout time.Duration) *GetFleetsFleetIDWingsParams {
	var (
		datasourceDefault = string("tranquility")
		languageDefault   = string("en-us")
	)
	return &GetFleetsFleetIDWingsParams{
		Datasource: &datasourceDefault,
		Language:   &languageDefault,

		timeout: timeout,
	}
}

// NewGetFleetsFleetIDWingsParamsWithContext creates a new GetFleetsFleetIDWingsParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetFleetsFleetIDWingsParamsWithContext(ctx context.Context) *GetFleetsFleetIDWingsParams {
	var (
		datasourceDefault = string("tranquility")
		languageDefault   = string("en-us")
	)
	return &GetFleetsFleetIDWingsParams{
		Datasource: &datasourceDefault,
		Language:   &languageDefault,

		Context: ctx,
	}
}

/*GetFleetsFleetIDWingsParams contains all the parameters to send to the API endpoint
for the get fleets fleet id wings operation typically these are written to a http.Request
*/
type GetFleetsFleetIDWingsParams struct {

	/*XUserAgent
	  Client identifier, takes precedence over User-Agent

	*/
	XUserAgent *string
	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*FleetID
	  ID for a fleet

	*/
	FleetID int64
	/*Language
	  Language to use in the response

	*/
	Language *string
	/*Token
	  Access token to use, if preferred over a header

	*/
	Token *string
	/*UserAgent
	  Client identifier, takes precedence over headers

	*/
	UserAgent *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get fleets fleet id wings params
func (o *GetFleetsFleetIDWingsParams) WithTimeout(timeout time.Duration) *GetFleetsFleetIDWingsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get fleets fleet id wings params
func (o *GetFleetsFleetIDWingsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get fleets fleet id wings params
func (o *GetFleetsFleetIDWingsParams) WithContext(ctx context.Context) *GetFleetsFleetIDWingsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get fleets fleet id wings params
func (o *GetFleetsFleetIDWingsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithXUserAgent adds the xUserAgent to the get fleets fleet id wings params
func (o *GetFleetsFleetIDWingsParams) WithXUserAgent(xUserAgent *string) *GetFleetsFleetIDWingsParams {
	o.SetXUserAgent(xUserAgent)
	return o
}

// SetXUserAgent adds the xUserAgent to the get fleets fleet id wings params
func (o *GetFleetsFleetIDWingsParams) SetXUserAgent(xUserAgent *string) {
	o.XUserAgent = xUserAgent
}

// WithDatasource adds the datasource to the get fleets fleet id wings params
func (o *GetFleetsFleetIDWingsParams) WithDatasource(datasource *string) *GetFleetsFleetIDWingsParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the get fleets fleet id wings params
func (o *GetFleetsFleetIDWingsParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithFleetID adds the fleetID to the get fleets fleet id wings params
func (o *GetFleetsFleetIDWingsParams) WithFleetID(fleetID int64) *GetFleetsFleetIDWingsParams {
	o.SetFleetID(fleetID)
	return o
}

// SetFleetID adds the fleetId to the get fleets fleet id wings params
func (o *GetFleetsFleetIDWingsParams) SetFleetID(fleetID int64) {
	o.FleetID = fleetID
}

// WithLanguage adds the language to the get fleets fleet id wings params
func (o *GetFleetsFleetIDWingsParams) WithLanguage(language *string) *GetFleetsFleetIDWingsParams {
	o.SetLanguage(language)
	return o
}

// SetLanguage adds the language to the get fleets fleet id wings params
func (o *GetFleetsFleetIDWingsParams) SetLanguage(language *string) {
	o.Language = language
}

// WithToken adds the token to the get fleets fleet id wings params
func (o *GetFleetsFleetIDWingsParams) WithToken(token *string) *GetFleetsFleetIDWingsParams {
	o.SetToken(token)
	return o
}

// SetToken adds the token to the get fleets fleet id wings params
func (o *GetFleetsFleetIDWingsParams) SetToken(token *string) {
	o.Token = token
}

// WithUserAgent adds the userAgent to the get fleets fleet id wings params
func (o *GetFleetsFleetIDWingsParams) WithUserAgent(userAgent *string) *GetFleetsFleetIDWingsParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the get fleets fleet id wings params
func (o *GetFleetsFleetIDWingsParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WriteToRequest writes these params to a swagger request
func (o *GetFleetsFleetIDWingsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	r.SetTimeout(o.timeout)
	var res []error

	if o.XUserAgent != nil {

		// header param X-User-Agent
		if err := r.SetHeaderParam("X-User-Agent", *o.XUserAgent); err != nil {
			return err
		}

	}

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	// path param fleet_id
	if err := r.SetPathParam("fleet_id", swag.FormatInt64(o.FleetID)); err != nil {
		return err
	}

	if o.Language != nil {

		// query param language
		var qrLanguage string
		if o.Language != nil {
			qrLanguage = *o.Language
		}
		qLanguage := qrLanguage
		if qLanguage != "" {
			if err := r.SetQueryParam("language", qLanguage); err != nil {
				return err
			}
		}

	}

	if o.Token != nil {

		// query param token
		var qrToken string
		if o.Token != nil {
			qrToken = *o.Token
		}
		qToken := qrToken
		if qToken != "" {
			if err := r.SetQueryParam("token", qToken); err != nil {
				return err
			}
		}

	}

	if o.UserAgent != nil {

		// query param user_agent
		var qrUserAgent string
		if o.UserAgent != nil {
			qrUserAgent = *o.UserAgent
		}
		qUserAgent := qrUserAgent
		if qUserAgent != "" {
			if err := r.SetQueryParam("user_agent", qUserAgent); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
