package industry

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// GetIndustrySystemsReader is a Reader for the GetIndustrySystems structure.
type GetIndustrySystemsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetIndustrySystemsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetIndustrySystemsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 500:
		result := NewGetIndustrySystemsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetIndustrySystemsOK creates a GetIndustrySystemsOK with default headers values
func NewGetIndustrySystemsOK() *GetIndustrySystemsOK {
	return &GetIndustrySystemsOK{}
}

/*GetIndustrySystemsOK handles this case with default header values.

A list of cost indicies
*/
type GetIndustrySystemsOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetIndustrySystemsOKBodyItems0
}

func (o *GetIndustrySystemsOK) Error() string {
	return fmt.Sprintf("[GET /industry/systems/][%d] getIndustrySystemsOK  %+v", 200, o.Payload)
}

func (o *GetIndustrySystemsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetIndustrySystemsInternalServerError creates a GetIndustrySystemsInternalServerError with default headers values
func NewGetIndustrySystemsInternalServerError() *GetIndustrySystemsInternalServerError {
	return &GetIndustrySystemsInternalServerError{}
}

/*GetIndustrySystemsInternalServerError handles this case with default header values.

Internal server error
*/
type GetIndustrySystemsInternalServerError struct {
	Payload GetIndustrySystemsInternalServerErrorBody
}

func (o *GetIndustrySystemsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /industry/systems/][%d] getIndustrySystemsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetIndustrySystemsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetIndustrySystemsOKBodyItems0 get_industry_systems_200_ok
//
// 200 ok object
swagger:model GetIndustrySystemsOKBodyItems0
*/
type GetIndustrySystemsOKBodyItems0 struct {

	// get_industry_systems_cost_indices
	//
	// cost_indices array
	// Required: true
	CostIndices []*GetIndustrySystemsOKBodyItems0CostIndicesItems0 `json:"cost_indices"`

	// get_industry_systems_solar_system_id
	//
	// solar_system_id integer
	// Required: true
	SolarSystemID *int32 `json:"solar_system_id"`
}

/*GetIndustrySystemsOKBodyItems0CostIndicesItems0 get_industry_systems_cost_indice
//
// cost_indice object
swagger:model GetIndustrySystemsOKBodyItems0CostIndicesItems0
*/
type GetIndustrySystemsOKBodyItems0CostIndicesItems0 struct {

	// get_industry_systems_activity
	//
	// activity string
	// Required: true
	Activity *string `json:"activity"`

	// get_industry_systems_cost_index
	//
	// cost_index number
	// Required: true
	CostIndex *float32 `json:"cost_index"`
}

/*GetIndustrySystemsInternalServerErrorBody get_industry_systems_internal_server_error
//
// Internal server error
swagger:model GetIndustrySystemsInternalServerErrorBody
*/
type GetIndustrySystemsInternalServerErrorBody struct {

	// get_industry_systems_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}
