package industry

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// New creates a new industry API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) *Client {
	return &Client{transport: transport, formats: formats}
}

/*
Client for industry API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

/*
GetIndustryFacilities lists industry facilities

Return a list of industry facilities

---

Alternate route: `/v1/industry/facilities/`

Alternate route: `/legacy/industry/facilities/`

Alternate route: `/dev/industry/facilities/`


---

This route is cached for up to 3600 seconds
*/
func (a *Client) GetIndustryFacilities(params *GetIndustryFacilitiesParams) (*GetIndustryFacilitiesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetIndustryFacilitiesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "get_industry_facilities",
		Method:             "GET",
		PathPattern:        "/industry/facilities/",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{""},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &GetIndustryFacilitiesReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetIndustryFacilitiesOK), nil

}

/*
GetIndustrySystems lists solar system cost indices

Return cost indices for solar systems

---

Alternate route: `/v1/industry/systems/`

Alternate route: `/legacy/industry/systems/`

Alternate route: `/dev/industry/systems/`


---

This route is cached for up to 3600 seconds
*/
func (a *Client) GetIndustrySystems(params *GetIndustrySystemsParams) (*GetIndustrySystemsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetIndustrySystemsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "get_industry_systems",
		Method:             "GET",
		PathPattern:        "/industry/systems/",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{""},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &GetIndustrySystemsReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetIndustrySystemsOK), nil

}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
