package killmails

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// GetCharactersCharacterIDKillmailsRecentReader is a Reader for the GetCharactersCharacterIDKillmailsRecent structure.
type GetCharactersCharacterIDKillmailsRecentReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCharactersCharacterIDKillmailsRecentReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetCharactersCharacterIDKillmailsRecentOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewGetCharactersCharacterIDKillmailsRecentForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetCharactersCharacterIDKillmailsRecentInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCharactersCharacterIDKillmailsRecentOK creates a GetCharactersCharacterIDKillmailsRecentOK with default headers values
func NewGetCharactersCharacterIDKillmailsRecentOK() *GetCharactersCharacterIDKillmailsRecentOK {
	return &GetCharactersCharacterIDKillmailsRecentOK{}
}

/*GetCharactersCharacterIDKillmailsRecentOK handles this case with default header values.

A list of killmail IDs and hashes
*/
type GetCharactersCharacterIDKillmailsRecentOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetCharactersCharacterIDKillmailsRecentOKBodyItems0
}

func (o *GetCharactersCharacterIDKillmailsRecentOK) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/killmails/recent/][%d] getCharactersCharacterIdKillmailsRecentOK  %+v", 200, o.Payload)
}

func (o *GetCharactersCharacterIDKillmailsRecentOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDKillmailsRecentForbidden creates a GetCharactersCharacterIDKillmailsRecentForbidden with default headers values
func NewGetCharactersCharacterIDKillmailsRecentForbidden() *GetCharactersCharacterIDKillmailsRecentForbidden {
	return &GetCharactersCharacterIDKillmailsRecentForbidden{}
}

/*GetCharactersCharacterIDKillmailsRecentForbidden handles this case with default header values.

Forbidden
*/
type GetCharactersCharacterIDKillmailsRecentForbidden struct {
	Payload GetCharactersCharacterIDKillmailsRecentForbiddenBody
}

func (o *GetCharactersCharacterIDKillmailsRecentForbidden) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/killmails/recent/][%d] getCharactersCharacterIdKillmailsRecentForbidden  %+v", 403, o.Payload)
}

func (o *GetCharactersCharacterIDKillmailsRecentForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDKillmailsRecentInternalServerError creates a GetCharactersCharacterIDKillmailsRecentInternalServerError with default headers values
func NewGetCharactersCharacterIDKillmailsRecentInternalServerError() *GetCharactersCharacterIDKillmailsRecentInternalServerError {
	return &GetCharactersCharacterIDKillmailsRecentInternalServerError{}
}

/*GetCharactersCharacterIDKillmailsRecentInternalServerError handles this case with default header values.

Internal server error
*/
type GetCharactersCharacterIDKillmailsRecentInternalServerError struct {
	Payload GetCharactersCharacterIDKillmailsRecentInternalServerErrorBody
}

func (o *GetCharactersCharacterIDKillmailsRecentInternalServerError) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/killmails/recent/][%d] getCharactersCharacterIdKillmailsRecentInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCharactersCharacterIDKillmailsRecentInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetCharactersCharacterIDKillmailsRecentOKBodyItems0 get_characters_character_id_killmails_recent_200_ok
//
// 200 ok object
swagger:model GetCharactersCharacterIDKillmailsRecentOKBodyItems0
*/
type GetCharactersCharacterIDKillmailsRecentOKBodyItems0 struct {

	// get_characters_character_id_killmails_recent_killmail_hash
	//
	// A hash of this killmail
	// Required: true
	KillmailHash *string `json:"killmail_hash"`

	// get_characters_character_id_killmails_recent_killmail_id
	//
	// ID of this killmail
	// Required: true
	KillmailID *int32 `json:"killmail_id"`
}

/*GetCharactersCharacterIDKillmailsRecentForbiddenBody get_characters_character_id_killmails_recent_forbidden
//
// Forbidden
swagger:model GetCharactersCharacterIDKillmailsRecentForbiddenBody
*/
type GetCharactersCharacterIDKillmailsRecentForbiddenBody struct {

	// get_characters_character_id_killmails_recent_403_forbidden
	//
	// Forbidden message
	// Required: true
	Error *string `json:"error"`
}

/*GetCharactersCharacterIDKillmailsRecentInternalServerErrorBody get_characters_character_id_killmails_recent_internal_server_error
//
// Internal server error
swagger:model GetCharactersCharacterIDKillmailsRecentInternalServerErrorBody
*/
type GetCharactersCharacterIDKillmailsRecentInternalServerErrorBody struct {

	// get_characters_character_id_killmails_recent_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}
