package market

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// GetMarketsRegionIDOrdersReader is a Reader for the GetMarketsRegionIDOrders structure.
type GetMarketsRegionIDOrdersReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetMarketsRegionIDOrdersReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetMarketsRegionIDOrdersOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 422:
		result := NewGetMarketsRegionIDOrdersUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetMarketsRegionIDOrdersInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetMarketsRegionIDOrdersOK creates a GetMarketsRegionIDOrdersOK with default headers values
func NewGetMarketsRegionIDOrdersOK() *GetMarketsRegionIDOrdersOK {
	return &GetMarketsRegionIDOrdersOK{}
}

/*GetMarketsRegionIDOrdersOK handles this case with default header values.

A list of orders
*/
type GetMarketsRegionIDOrdersOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetMarketsRegionIDOrdersOKBodyItems0
}

func (o *GetMarketsRegionIDOrdersOK) Error() string {
	return fmt.Sprintf("[GET /markets/{region_id}/orders/][%d] getMarketsRegionIdOrdersOK  %+v", 200, o.Payload)
}

func (o *GetMarketsRegionIDOrdersOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetMarketsRegionIDOrdersUnprocessableEntity creates a GetMarketsRegionIDOrdersUnprocessableEntity with default headers values
func NewGetMarketsRegionIDOrdersUnprocessableEntity() *GetMarketsRegionIDOrdersUnprocessableEntity {
	return &GetMarketsRegionIDOrdersUnprocessableEntity{}
}

/*GetMarketsRegionIDOrdersUnprocessableEntity handles this case with default header values.

Not found
*/
type GetMarketsRegionIDOrdersUnprocessableEntity struct {
	Payload GetMarketsRegionIDOrdersUnprocessableEntityBody
}

func (o *GetMarketsRegionIDOrdersUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /markets/{region_id}/orders/][%d] getMarketsRegionIdOrdersUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetMarketsRegionIDOrdersUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetMarketsRegionIDOrdersInternalServerError creates a GetMarketsRegionIDOrdersInternalServerError with default headers values
func NewGetMarketsRegionIDOrdersInternalServerError() *GetMarketsRegionIDOrdersInternalServerError {
	return &GetMarketsRegionIDOrdersInternalServerError{}
}

/*GetMarketsRegionIDOrdersInternalServerError handles this case with default header values.

Internal server error
*/
type GetMarketsRegionIDOrdersInternalServerError struct {
	Payload GetMarketsRegionIDOrdersInternalServerErrorBody
}

func (o *GetMarketsRegionIDOrdersInternalServerError) Error() string {
	return fmt.Sprintf("[GET /markets/{region_id}/orders/][%d] getMarketsRegionIdOrdersInternalServerError  %+v", 500, o.Payload)
}

func (o *GetMarketsRegionIDOrdersInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetMarketsRegionIDOrdersOKBodyItems0 get_markets_region_id_orders_200_ok
//
// 200 ok object
swagger:model GetMarketsRegionIDOrdersOKBodyItems0
*/
type GetMarketsRegionIDOrdersOKBodyItems0 struct {

	// get_markets_region_id_orders_duration
	//
	// duration integer
	// Required: true
	Duration *int32 `json:"duration"`

	// get_markets_region_id_orders_is_buy_order
	//
	// is_buy_order boolean
	// Required: true
	IsBuyOrder *bool `json:"is_buy_order"`

	// get_markets_region_id_orders_issued
	//
	// issued string
	// Required: true
	Issued *strfmt.DateTime `json:"issued"`

	// get_markets_region_id_orders_location_id
	//
	// location_id integer
	// Required: true
	LocationID *int64 `json:"location_id"`

	// get_markets_region_id_orders_min_volume
	//
	// min_volume integer
	// Required: true
	MinVolume *int32 `json:"min_volume"`

	// get_markets_region_id_orders_order_id
	//
	// order_id integer
	// Required: true
	OrderID *int64 `json:"order_id"`

	// get_markets_region_id_orders_price
	//
	// price number
	// Required: true
	Price *float32 `json:"price"`

	// get_markets_region_id_orders_range
	//
	// range string
	// Required: true
	Range *string `json:"range"`

	// get_markets_region_id_orders_type_id
	//
	// type_id integer
	// Required: true
	TypeID *int32 `json:"type_id"`

	// get_markets_region_id_orders_volume_remain
	//
	// volume_remain integer
	// Required: true
	VolumeRemain *int32 `json:"volume_remain"`

	// get_markets_region_id_orders_volume_total
	//
	// volume_total integer
	// Required: true
	VolumeTotal *int32 `json:"volume_total"`
}

/*GetMarketsRegionIDOrdersUnprocessableEntityBody get_markets_region_id_orders_unprocessable_entity
//
// Unprocessable entity
swagger:model GetMarketsRegionIDOrdersUnprocessableEntityBody
*/
type GetMarketsRegionIDOrdersUnprocessableEntityBody struct {

	// get_markets_region_id_orders_422_unprocessable_entity
	//
	// Unprocessable entity message
	// Required: true
	Error *string `json:"error"`
}

/*GetMarketsRegionIDOrdersInternalServerErrorBody get_markets_region_id_orders_internal_server_error
//
// Internal server error
swagger:model GetMarketsRegionIDOrdersInternalServerErrorBody
*/
type GetMarketsRegionIDOrdersInternalServerErrorBody struct {

	// get_markets_region_id_orders_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}
