package market

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// GetMarketsStructuresStructureIDReader is a Reader for the GetMarketsStructuresStructureID structure.
type GetMarketsStructuresStructureIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetMarketsStructuresStructureIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetMarketsStructuresStructureIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewGetMarketsStructuresStructureIDForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetMarketsStructuresStructureIDInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetMarketsStructuresStructureIDOK creates a GetMarketsStructuresStructureIDOK with default headers values
func NewGetMarketsStructuresStructureIDOK() *GetMarketsStructuresStructureIDOK {
	return &GetMarketsStructuresStructureIDOK{}
}

/*GetMarketsStructuresStructureIDOK handles this case with default header values.

A list of orders
*/
type GetMarketsStructuresStructureIDOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetMarketsStructuresStructureIDOKBodyItems0
}

func (o *GetMarketsStructuresStructureIDOK) Error() string {
	return fmt.Sprintf("[GET /markets/structures/{structure_id}/][%d] getMarketsStructuresStructureIdOK  %+v", 200, o.Payload)
}

func (o *GetMarketsStructuresStructureIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetMarketsStructuresStructureIDForbidden creates a GetMarketsStructuresStructureIDForbidden with default headers values
func NewGetMarketsStructuresStructureIDForbidden() *GetMarketsStructuresStructureIDForbidden {
	return &GetMarketsStructuresStructureIDForbidden{}
}

/*GetMarketsStructuresStructureIDForbidden handles this case with default header values.

Forbidden
*/
type GetMarketsStructuresStructureIDForbidden struct {
	Payload GetMarketsStructuresStructureIDForbiddenBody
}

func (o *GetMarketsStructuresStructureIDForbidden) Error() string {
	return fmt.Sprintf("[GET /markets/structures/{structure_id}/][%d] getMarketsStructuresStructureIdForbidden  %+v", 403, o.Payload)
}

func (o *GetMarketsStructuresStructureIDForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetMarketsStructuresStructureIDInternalServerError creates a GetMarketsStructuresStructureIDInternalServerError with default headers values
func NewGetMarketsStructuresStructureIDInternalServerError() *GetMarketsStructuresStructureIDInternalServerError {
	return &GetMarketsStructuresStructureIDInternalServerError{}
}

/*GetMarketsStructuresStructureIDInternalServerError handles this case with default header values.

Internal server error
*/
type GetMarketsStructuresStructureIDInternalServerError struct {
	Payload GetMarketsStructuresStructureIDInternalServerErrorBody
}

func (o *GetMarketsStructuresStructureIDInternalServerError) Error() string {
	return fmt.Sprintf("[GET /markets/structures/{structure_id}/][%d] getMarketsStructuresStructureIdInternalServerError  %+v", 500, o.Payload)
}

func (o *GetMarketsStructuresStructureIDInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetMarketsStructuresStructureIDOKBodyItems0 get_markets_structures_structure_id_200_ok
//
// 200 ok object
swagger:model GetMarketsStructuresStructureIDOKBodyItems0
*/
type GetMarketsStructuresStructureIDOKBodyItems0 struct {

	// get_markets_structures_structure_id_duration
	//
	// duration integer
	// Required: true
	Duration *int32 `json:"duration"`

	// get_markets_structures_structure_id_is_buy_order
	//
	// is_buy_order boolean
	// Required: true
	IsBuyOrder *bool `json:"is_buy_order"`

	// get_markets_structures_structure_id_issued
	//
	// issued string
	// Required: true
	Issued *strfmt.DateTime `json:"issued"`

	// get_markets_structures_structure_id_location_id
	//
	// location_id integer
	// Required: true
	LocationID *int64 `json:"location_id"`

	// get_markets_structures_structure_id_min_volume
	//
	// min_volume integer
	// Required: true
	MinVolume *int32 `json:"min_volume"`

	// get_markets_structures_structure_id_order_id
	//
	// order_id integer
	// Required: true
	OrderID *int64 `json:"order_id"`

	// get_markets_structures_structure_id_price
	//
	// price number
	// Required: true
	Price *float32 `json:"price"`

	// get_markets_structures_structure_id_range
	//
	// range string
	// Required: true
	Range *string `json:"range"`

	// get_markets_structures_structure_id_type_id
	//
	// type_id integer
	// Required: true
	TypeID *int32 `json:"type_id"`

	// get_markets_structures_structure_id_volume_remain
	//
	// volume_remain integer
	// Required: true
	VolumeRemain *int32 `json:"volume_remain"`

	// get_markets_structures_structure_id_volume_total
	//
	// volume_total integer
	// Required: true
	VolumeTotal *int32 `json:"volume_total"`
}

/*GetMarketsStructuresStructureIDForbiddenBody get_markets_structures_structure_id_forbidden
//
// Forbidden
swagger:model GetMarketsStructuresStructureIDForbiddenBody
*/
type GetMarketsStructuresStructureIDForbiddenBody struct {

	// get_markets_structures_structure_id_403_forbidden
	//
	// Forbidden message
	// Required: true
	Error *string `json:"error"`
}

/*GetMarketsStructuresStructureIDInternalServerErrorBody get_markets_structures_structure_id_internal_server_error
//
// Internal server error
swagger:model GetMarketsStructuresStructureIDInternalServerErrorBody
*/
type GetMarketsStructuresStructureIDInternalServerErrorBody struct {

	// get_markets_structures_structure_id_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}
