package planetary_interaction

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// GetCharactersCharacterIDPlanetsReader is a Reader for the GetCharactersCharacterIDPlanets structure.
type GetCharactersCharacterIDPlanetsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCharactersCharacterIDPlanetsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetCharactersCharacterIDPlanetsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewGetCharactersCharacterIDPlanetsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetCharactersCharacterIDPlanetsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCharactersCharacterIDPlanetsOK creates a GetCharactersCharacterIDPlanetsOK with default headers values
func NewGetCharactersCharacterIDPlanetsOK() *GetCharactersCharacterIDPlanetsOK {
	return &GetCharactersCharacterIDPlanetsOK{}
}

/*GetCharactersCharacterIDPlanetsOK handles this case with default header values.

List of colonies
*/
type GetCharactersCharacterIDPlanetsOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetCharactersCharacterIDPlanetsOKBodyItems0
}

func (o *GetCharactersCharacterIDPlanetsOK) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/planets/][%d] getCharactersCharacterIdPlanetsOK  %+v", 200, o.Payload)
}

func (o *GetCharactersCharacterIDPlanetsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDPlanetsForbidden creates a GetCharactersCharacterIDPlanetsForbidden with default headers values
func NewGetCharactersCharacterIDPlanetsForbidden() *GetCharactersCharacterIDPlanetsForbidden {
	return &GetCharactersCharacterIDPlanetsForbidden{}
}

/*GetCharactersCharacterIDPlanetsForbidden handles this case with default header values.

Forbidden
*/
type GetCharactersCharacterIDPlanetsForbidden struct {
	Payload GetCharactersCharacterIDPlanetsForbiddenBody
}

func (o *GetCharactersCharacterIDPlanetsForbidden) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/planets/][%d] getCharactersCharacterIdPlanetsForbidden  %+v", 403, o.Payload)
}

func (o *GetCharactersCharacterIDPlanetsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDPlanetsInternalServerError creates a GetCharactersCharacterIDPlanetsInternalServerError with default headers values
func NewGetCharactersCharacterIDPlanetsInternalServerError() *GetCharactersCharacterIDPlanetsInternalServerError {
	return &GetCharactersCharacterIDPlanetsInternalServerError{}
}

/*GetCharactersCharacterIDPlanetsInternalServerError handles this case with default header values.

Internal server error
*/
type GetCharactersCharacterIDPlanetsInternalServerError struct {
	Payload GetCharactersCharacterIDPlanetsInternalServerErrorBody
}

func (o *GetCharactersCharacterIDPlanetsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/planets/][%d] getCharactersCharacterIdPlanetsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCharactersCharacterIDPlanetsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetCharactersCharacterIDPlanetsForbiddenBody get_characters_character_id_planets_forbidden
//
// Forbidden
swagger:model GetCharactersCharacterIDPlanetsForbiddenBody
*/
type GetCharactersCharacterIDPlanetsForbiddenBody struct {

	// get_characters_character_id_planets_403_forbidden
	//
	// Forbidden message
	// Required: true
	Error *string `json:"error"`
}

/*GetCharactersCharacterIDPlanetsInternalServerErrorBody get_characters_character_id_planets_internal_server_error
//
// Internal server error
swagger:model GetCharactersCharacterIDPlanetsInternalServerErrorBody
*/
type GetCharactersCharacterIDPlanetsInternalServerErrorBody struct {

	// get_characters_character_id_planets_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}

/*GetCharactersCharacterIDPlanetsOKBodyItems0 get_characters_character_id_planets_200_ok
//
// 200 ok object
swagger:model GetCharactersCharacterIDPlanetsOKBodyItems0
*/
type GetCharactersCharacterIDPlanetsOKBodyItems0 struct {

	// get_characters_character_id_planets_last_update
	//
	// last_update string
	// Required: true
	LastUpdate *strfmt.DateTime `json:"last_update"`

	// get_characters_character_id_planets_num_pins
	//
	// num_pins integer
	// Required: true
	// Minimum: 1
	NumPins *int32 `json:"num_pins"`

	// get_characters_character_id_planets_owner_id
	//
	// owner_id integer
	// Required: true
	OwnerID *int32 `json:"owner_id"`

	// get_characters_character_id_planets_planet_id
	//
	// planet_id integer
	// Required: true
	PlanetID *int32 `json:"planet_id"`

	// get_characters_character_id_planets_planet_type
	//
	// planet_type string
	// Required: true
	PlanetType *string `json:"planet_type"`

	// get_characters_character_id_planets_solar_system_id
	//
	// solar_system_id integer
	// Required: true
	SolarSystemID *int32 `json:"solar_system_id"`

	// get_characters_character_id_planets_upgrade_level
	//
	// upgrade_level integer
	// Required: true
	// Maximum: 5
	// Minimum: 0
	UpgradeLevel *int32 `json:"upgrade_level"`
}
