package planetary_interaction

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// GetUniverseSchematicsSchematicIDReader is a Reader for the GetUniverseSchematicsSchematicID structure.
type GetUniverseSchematicsSchematicIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetUniverseSchematicsSchematicIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetUniverseSchematicsSchematicIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 404:
		result := NewGetUniverseSchematicsSchematicIDNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetUniverseSchematicsSchematicIDInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetUniverseSchematicsSchematicIDOK creates a GetUniverseSchematicsSchematicIDOK with default headers values
func NewGetUniverseSchematicsSchematicIDOK() *GetUniverseSchematicsSchematicIDOK {
	return &GetUniverseSchematicsSchematicIDOK{}
}

/*GetUniverseSchematicsSchematicIDOK handles this case with default header values.

Public data about a schematic
*/
type GetUniverseSchematicsSchematicIDOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload GetUniverseSchematicsSchematicIDOKBody
}

func (o *GetUniverseSchematicsSchematicIDOK) Error() string {
	return fmt.Sprintf("[GET /universe/schematics/{schematic_id}/][%d] getUniverseSchematicsSchematicIdOK  %+v", 200, o.Payload)
}

func (o *GetUniverseSchematicsSchematicIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetUniverseSchematicsSchematicIDNotFound creates a GetUniverseSchematicsSchematicIDNotFound with default headers values
func NewGetUniverseSchematicsSchematicIDNotFound() *GetUniverseSchematicsSchematicIDNotFound {
	return &GetUniverseSchematicsSchematicIDNotFound{}
}

/*GetUniverseSchematicsSchematicIDNotFound handles this case with default header values.

Schematic not found
*/
type GetUniverseSchematicsSchematicIDNotFound struct {
	Payload GetUniverseSchematicsSchematicIDNotFoundBody
}

func (o *GetUniverseSchematicsSchematicIDNotFound) Error() string {
	return fmt.Sprintf("[GET /universe/schematics/{schematic_id}/][%d] getUniverseSchematicsSchematicIdNotFound  %+v", 404, o.Payload)
}

func (o *GetUniverseSchematicsSchematicIDNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetUniverseSchematicsSchematicIDInternalServerError creates a GetUniverseSchematicsSchematicIDInternalServerError with default headers values
func NewGetUniverseSchematicsSchematicIDInternalServerError() *GetUniverseSchematicsSchematicIDInternalServerError {
	return &GetUniverseSchematicsSchematicIDInternalServerError{}
}

/*GetUniverseSchematicsSchematicIDInternalServerError handles this case with default header values.

Internal server error
*/
type GetUniverseSchematicsSchematicIDInternalServerError struct {
	Payload GetUniverseSchematicsSchematicIDInternalServerErrorBody
}

func (o *GetUniverseSchematicsSchematicIDInternalServerError) Error() string {
	return fmt.Sprintf("[GET /universe/schematics/{schematic_id}/][%d] getUniverseSchematicsSchematicIdInternalServerError  %+v", 500, o.Payload)
}

func (o *GetUniverseSchematicsSchematicIDInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetUniverseSchematicsSchematicIDOKBody get_universe_schematics_schematic_id_ok
//
// 200 ok object
swagger:model GetUniverseSchematicsSchematicIDOKBody
*/
type GetUniverseSchematicsSchematicIDOKBody struct {

	// get_universe_schematics_schematic_id_cycle_time
	//
	// Time in seconds to process a run
	// Required: true
	CycleTime *int32 `json:"cycle_time"`

	// get_universe_schematics_schematic_id_schematic_name
	//
	// schematic_name string
	// Required: true
	SchematicName *string `json:"schematic_name"`
}

/*GetUniverseSchematicsSchematicIDNotFoundBody get_universe_schematics_schematic_id_not_found
//
// Schematic not found
swagger:model GetUniverseSchematicsSchematicIDNotFoundBody
*/
type GetUniverseSchematicsSchematicIDNotFoundBody struct {

	// get_universe_schematics_schematic_id_error
	//
	// error message
	// Required: true
	Error *string `json:"error"`
}

/*GetUniverseSchematicsSchematicIDInternalServerErrorBody get_universe_schematics_schematic_id_internal_server_error
//
// Internal server error
swagger:model GetUniverseSchematicsSchematicIDInternalServerErrorBody
*/
type GetUniverseSchematicsSchematicIDInternalServerErrorBody struct {

	// get_universe_schematics_schematic_id_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}
