package search

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetSearchParams creates a new GetSearchParams object
// with the default values initialized.
func NewGetSearchParams() *GetSearchParams {
	var (
		datasourceDefault = string("tranquility")
		languageDefault   = string("en-us")
		strictDefault     = bool(false)
	)
	return &GetSearchParams{
		Datasource: &datasourceDefault,
		Language:   &languageDefault,
		Strict:     &strictDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetSearchParamsWithTimeout creates a new GetSearchParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetSearchParamsWithTimeout(timeout time.Duration) *GetSearchParams {
	var (
		datasourceDefault = string("tranquility")
		languageDefault   = string("en-us")
		strictDefault     = bool(false)
	)
	return &GetSearchParams{
		Datasource: &datasourceDefault,
		Language:   &languageDefault,
		Strict:     &strictDefault,

		timeout: timeout,
	}
}

// NewGetSearchParamsWithContext creates a new GetSearchParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetSearchParamsWithContext(ctx context.Context) *GetSearchParams {
	var (
		datasourceDefault = string("tranquility")
		languageDefault   = string("en-us")
		strictDefault     = bool(false)
	)
	return &GetSearchParams{
		Datasource: &datasourceDefault,
		Language:   &languageDefault,
		Strict:     &strictDefault,

		Context: ctx,
	}
}

/*GetSearchParams contains all the parameters to send to the API endpoint
for the get search operation typically these are written to a http.Request
*/
type GetSearchParams struct {

	/*XUserAgent
	  Client identifier, takes precedence over User-Agent

	*/
	XUserAgent *string
	/*Categories
	  Type of entities to search for

	*/
	Categories []string
	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*Language
	  Search locale

	*/
	Language *string
	/*Search
	  The string to search on

	*/
	Search string
	/*Strict
	  Whether the search should be a strict match

	*/
	Strict *bool
	/*UserAgent
	  Client identifier, takes precedence over headers

	*/
	UserAgent *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get search params
func (o *GetSearchParams) WithTimeout(timeout time.Duration) *GetSearchParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get search params
func (o *GetSearchParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get search params
func (o *GetSearchParams) WithContext(ctx context.Context) *GetSearchParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get search params
func (o *GetSearchParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithXUserAgent adds the xUserAgent to the get search params
func (o *GetSearchParams) WithXUserAgent(xUserAgent *string) *GetSearchParams {
	o.SetXUserAgent(xUserAgent)
	return o
}

// SetXUserAgent adds the xUserAgent to the get search params
func (o *GetSearchParams) SetXUserAgent(xUserAgent *string) {
	o.XUserAgent = xUserAgent
}

// WithCategories adds the categories to the get search params
func (o *GetSearchParams) WithCategories(categories []string) *GetSearchParams {
	o.SetCategories(categories)
	return o
}

// SetCategories adds the categories to the get search params
func (o *GetSearchParams) SetCategories(categories []string) {
	o.Categories = categories
}

// WithDatasource adds the datasource to the get search params
func (o *GetSearchParams) WithDatasource(datasource *string) *GetSearchParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the get search params
func (o *GetSearchParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithLanguage adds the language to the get search params
func (o *GetSearchParams) WithLanguage(language *string) *GetSearchParams {
	o.SetLanguage(language)
	return o
}

// SetLanguage adds the language to the get search params
func (o *GetSearchParams) SetLanguage(language *string) {
	o.Language = language
}

// WithSearch adds the search to the get search params
func (o *GetSearchParams) WithSearch(search string) *GetSearchParams {
	o.SetSearch(search)
	return o
}

// SetSearch adds the search to the get search params
func (o *GetSearchParams) SetSearch(search string) {
	o.Search = search
}

// WithStrict adds the strict to the get search params
func (o *GetSearchParams) WithStrict(strict *bool) *GetSearchParams {
	o.SetStrict(strict)
	return o
}

// SetStrict adds the strict to the get search params
func (o *GetSearchParams) SetStrict(strict *bool) {
	o.Strict = strict
}

// WithUserAgent adds the userAgent to the get search params
func (o *GetSearchParams) WithUserAgent(userAgent *string) *GetSearchParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the get search params
func (o *GetSearchParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WriteToRequest writes these params to a swagger request
func (o *GetSearchParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	r.SetTimeout(o.timeout)
	var res []error

	if o.XUserAgent != nil {

		// header param X-User-Agent
		if err := r.SetHeaderParam("X-User-Agent", *o.XUserAgent); err != nil {
			return err
		}

	}

	valuesCategories := o.Categories

	joinedCategories := swag.JoinByFormat(valuesCategories, "")
	// query array param categories
	if err := r.SetQueryParam("categories", joinedCategories...); err != nil {
		return err
	}

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	if o.Language != nil {

		// query param language
		var qrLanguage string
		if o.Language != nil {
			qrLanguage = *o.Language
		}
		qLanguage := qrLanguage
		if qLanguage != "" {
			if err := r.SetQueryParam("language", qLanguage); err != nil {
				return err
			}
		}

	}

	// query param search
	qrSearch := o.Search
	qSearch := qrSearch
	if qSearch != "" {
		if err := r.SetQueryParam("search", qSearch); err != nil {
			return err
		}
	}

	if o.Strict != nil {

		// query param strict
		var qrStrict bool
		if o.Strict != nil {
			qrStrict = *o.Strict
		}
		qStrict := swag.FormatBool(qrStrict)
		if qStrict != "" {
			if err := r.SetQueryParam("strict", qStrict); err != nil {
				return err
			}
		}

	}

	if o.UserAgent != nil {

		// query param user_agent
		var qrUserAgent string
		if o.UserAgent != nil {
			qrUserAgent = *o.UserAgent
		}
		qUserAgent := qrUserAgent
		if qUserAgent != "" {
			if err := r.SetQueryParam("user_agent", qUserAgent); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
