package universe

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// GetUniverseConstellationsReader is a Reader for the GetUniverseConstellations structure.
type GetUniverseConstellationsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetUniverseConstellationsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetUniverseConstellationsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 500:
		result := NewGetUniverseConstellationsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetUniverseConstellationsOK creates a GetUniverseConstellationsOK with default headers values
func NewGetUniverseConstellationsOK() *GetUniverseConstellationsOK {
	return &GetUniverseConstellationsOK{}
}

/*GetUniverseConstellationsOK handles this case with default header values.

A list of constellation ids
*/
type GetUniverseConstellationsOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []int32
}

func (o *GetUniverseConstellationsOK) Error() string {
	return fmt.Sprintf("[GET /universe/constellations/][%d] getUniverseConstellationsOK  %+v", 200, o.Payload)
}

func (o *GetUniverseConstellationsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetUniverseConstellationsInternalServerError creates a GetUniverseConstellationsInternalServerError with default headers values
func NewGetUniverseConstellationsInternalServerError() *GetUniverseConstellationsInternalServerError {
	return &GetUniverseConstellationsInternalServerError{}
}

/*GetUniverseConstellationsInternalServerError handles this case with default header values.

Internal server error
*/
type GetUniverseConstellationsInternalServerError struct {
	Payload GetUniverseConstellationsInternalServerErrorBody
}

func (o *GetUniverseConstellationsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /universe/constellations/][%d] getUniverseConstellationsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetUniverseConstellationsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetUniverseConstellationsInternalServerErrorBody get_universe_constellations_internal_server_error
//
// Internal server error
swagger:model GetUniverseConstellationsInternalServerErrorBody
*/
type GetUniverseConstellationsInternalServerErrorBody struct {

	// get_universe_constellations_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}
