package universe

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// GetUniverseFactionsReader is a Reader for the GetUniverseFactions structure.
type GetUniverseFactionsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetUniverseFactionsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetUniverseFactionsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 500:
		result := NewGetUniverseFactionsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetUniverseFactionsOK creates a GetUniverseFactionsOK with default headers values
func NewGetUniverseFactionsOK() *GetUniverseFactionsOK {
	return &GetUniverseFactionsOK{}
}

/*GetUniverseFactionsOK handles this case with default header values.

A list of factions
*/
type GetUniverseFactionsOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*The language used in the response
	 */
	ContentLanguage string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetUniverseFactionsOKBodyItems0
}

func (o *GetUniverseFactionsOK) Error() string {
	return fmt.Sprintf("[GET /universe/factions/][%d] getUniverseFactionsOK  %+v", 200, o.Payload)
}

func (o *GetUniverseFactionsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Content-Language
	o.ContentLanguage = response.GetHeader("Content-Language")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetUniverseFactionsInternalServerError creates a GetUniverseFactionsInternalServerError with default headers values
func NewGetUniverseFactionsInternalServerError() *GetUniverseFactionsInternalServerError {
	return &GetUniverseFactionsInternalServerError{}
}

/*GetUniverseFactionsInternalServerError handles this case with default header values.

Internal server error
*/
type GetUniverseFactionsInternalServerError struct {
	Payload GetUniverseFactionsInternalServerErrorBody
}

func (o *GetUniverseFactionsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /universe/factions/][%d] getUniverseFactionsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetUniverseFactionsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetUniverseFactionsOKBodyItems0 get_universe_factions_200_ok
//
// 200 ok object
swagger:model GetUniverseFactionsOKBodyItems0
*/
type GetUniverseFactionsOKBodyItems0 struct {

	// get_universe_factions_corporation_id
	//
	// corporation_id integer
	// Required: true
	CorporationID *int32 `json:"corporation_id"`

	// get_universe_factions_description
	//
	// description string
	// Required: true
	Description *string `json:"description"`

	// get_universe_factions_faction_id
	//
	// faction_id integer
	// Required: true
	FactionID *int32 `json:"faction_id"`

	// get_universe_factions_is_unique
	//
	// is_unique boolean
	// Required: true
	IsUnique *bool `json:"is_unique"`

	// get_universe_factions_militia_corporation_id
	//
	// militia_corporation_id integer
	MilitiaCorporationID int32 `json:"militia_corporation_id,omitempty"`

	// get_universe_factions_name
	//
	// name string
	// Required: true
	Name *string `json:"name"`

	// get_universe_factions_size_factor
	//
	// size_factor number
	// Required: true
	SizeFactor *float32 `json:"size_factor"`

	// get_universe_factions_solar_system_id
	//
	// solar_system_id integer
	// Required: true
	SolarSystemID *int32 `json:"solar_system_id"`

	// get_universe_factions_station_count
	//
	// station_count integer
	// Required: true
	StationCount *int32 `json:"station_count"`

	// get_universe_factions_station_system_count
	//
	// station_system_count integer
	// Required: true
	StationSystemCount *int32 `json:"station_system_count"`
}

/*GetUniverseFactionsInternalServerErrorBody get_universe_factions_internal_server_error
//
// Internal server error
swagger:model GetUniverseFactionsInternalServerErrorBody
*/
type GetUniverseFactionsInternalServerErrorBody struct {

	// get_universe_factions_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}
