package universe

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetUniverseGraphicsParams creates a new GetUniverseGraphicsParams object
// with the default values initialized.
func NewGetUniverseGraphicsParams() *GetUniverseGraphicsParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetUniverseGraphicsParams{
		Datasource: &datasourceDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetUniverseGraphicsParamsWithTimeout creates a new GetUniverseGraphicsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetUniverseGraphicsParamsWithTimeout(timeout time.Duration) *GetUniverseGraphicsParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetUniverseGraphicsParams{
		Datasource: &datasourceDefault,

		timeout: timeout,
	}
}

// NewGetUniverseGraphicsParamsWithContext creates a new GetUniverseGraphicsParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetUniverseGraphicsParamsWithContext(ctx context.Context) *GetUniverseGraphicsParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetUniverseGraphicsParams{
		Datasource: &datasourceDefault,

		Context: ctx,
	}
}

/*GetUniverseGraphicsParams contains all the parameters to send to the API endpoint
for the get universe graphics operation typically these are written to a http.Request
*/
type GetUniverseGraphicsParams struct {

	/*XUserAgent
	  Client identifier, takes precedence over User-Agent

	*/
	XUserAgent *string
	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*UserAgent
	  Client identifier, takes precedence over headers

	*/
	UserAgent *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get universe graphics params
func (o *GetUniverseGraphicsParams) WithTimeout(timeout time.Duration) *GetUniverseGraphicsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get universe graphics params
func (o *GetUniverseGraphicsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get universe graphics params
func (o *GetUniverseGraphicsParams) WithContext(ctx context.Context) *GetUniverseGraphicsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get universe graphics params
func (o *GetUniverseGraphicsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithXUserAgent adds the xUserAgent to the get universe graphics params
func (o *GetUniverseGraphicsParams) WithXUserAgent(xUserAgent *string) *GetUniverseGraphicsParams {
	o.SetXUserAgent(xUserAgent)
	return o
}

// SetXUserAgent adds the xUserAgent to the get universe graphics params
func (o *GetUniverseGraphicsParams) SetXUserAgent(xUserAgent *string) {
	o.XUserAgent = xUserAgent
}

// WithDatasource adds the datasource to the get universe graphics params
func (o *GetUniverseGraphicsParams) WithDatasource(datasource *string) *GetUniverseGraphicsParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the get universe graphics params
func (o *GetUniverseGraphicsParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithUserAgent adds the userAgent to the get universe graphics params
func (o *GetUniverseGraphicsParams) WithUserAgent(userAgent *string) *GetUniverseGraphicsParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the get universe graphics params
func (o *GetUniverseGraphicsParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WriteToRequest writes these params to a swagger request
func (o *GetUniverseGraphicsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	r.SetTimeout(o.timeout)
	var res []error

	if o.XUserAgent != nil {

		// header param X-User-Agent
		if err := r.SetHeaderParam("X-User-Agent", *o.XUserAgent); err != nil {
			return err
		}

	}

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	if o.UserAgent != nil {

		// query param user_agent
		var qrUserAgent string
		if o.UserAgent != nil {
			qrUserAgent = *o.UserAgent
		}
		qUserAgent := qrUserAgent
		if qUserAgent != "" {
			if err := r.SetQueryParam("user_agent", qUserAgent); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
