package universe

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// GetUniverseMoonsMoonIDReader is a Reader for the GetUniverseMoonsMoonID structure.
type GetUniverseMoonsMoonIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetUniverseMoonsMoonIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetUniverseMoonsMoonIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 404:
		result := NewGetUniverseMoonsMoonIDNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetUniverseMoonsMoonIDInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetUniverseMoonsMoonIDOK creates a GetUniverseMoonsMoonIDOK with default headers values
func NewGetUniverseMoonsMoonIDOK() *GetUniverseMoonsMoonIDOK {
	return &GetUniverseMoonsMoonIDOK{}
}

/*GetUniverseMoonsMoonIDOK handles this case with default header values.

Information about a moon
*/
type GetUniverseMoonsMoonIDOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload GetUniverseMoonsMoonIDOKBody
}

func (o *GetUniverseMoonsMoonIDOK) Error() string {
	return fmt.Sprintf("[GET /universe/moons/{moon_id}/][%d] getUniverseMoonsMoonIdOK  %+v", 200, o.Payload)
}

func (o *GetUniverseMoonsMoonIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetUniverseMoonsMoonIDNotFound creates a GetUniverseMoonsMoonIDNotFound with default headers values
func NewGetUniverseMoonsMoonIDNotFound() *GetUniverseMoonsMoonIDNotFound {
	return &GetUniverseMoonsMoonIDNotFound{}
}

/*GetUniverseMoonsMoonIDNotFound handles this case with default header values.

Moon not found
*/
type GetUniverseMoonsMoonIDNotFound struct {
	Payload GetUniverseMoonsMoonIDNotFoundBody
}

func (o *GetUniverseMoonsMoonIDNotFound) Error() string {
	return fmt.Sprintf("[GET /universe/moons/{moon_id}/][%d] getUniverseMoonsMoonIdNotFound  %+v", 404, o.Payload)
}

func (o *GetUniverseMoonsMoonIDNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetUniverseMoonsMoonIDInternalServerError creates a GetUniverseMoonsMoonIDInternalServerError with default headers values
func NewGetUniverseMoonsMoonIDInternalServerError() *GetUniverseMoonsMoonIDInternalServerError {
	return &GetUniverseMoonsMoonIDInternalServerError{}
}

/*GetUniverseMoonsMoonIDInternalServerError handles this case with default header values.

Internal server error
*/
type GetUniverseMoonsMoonIDInternalServerError struct {
	Payload GetUniverseMoonsMoonIDInternalServerErrorBody
}

func (o *GetUniverseMoonsMoonIDInternalServerError) Error() string {
	return fmt.Sprintf("[GET /universe/moons/{moon_id}/][%d] getUniverseMoonsMoonIdInternalServerError  %+v", 500, o.Payload)
}

func (o *GetUniverseMoonsMoonIDInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetUniverseMoonsMoonIDNotFoundBody get_universe_moons_moon_id_not_found
//
// Not found
swagger:model GetUniverseMoonsMoonIDNotFoundBody
*/
type GetUniverseMoonsMoonIDNotFoundBody struct {

	// get_universe_moons_moon_id_404_not_found
	//
	// Not found message
	// Required: true
	Error *string `json:"error"`
}

/*GetUniverseMoonsMoonIDInternalServerErrorBody get_universe_moons_moon_id_internal_server_error
//
// Internal server error
swagger:model GetUniverseMoonsMoonIDInternalServerErrorBody
*/
type GetUniverseMoonsMoonIDInternalServerErrorBody struct {

	// get_universe_moons_moon_id_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}

/*GetUniverseMoonsMoonIDOKBodyPosition get_universe_moons_moon_id_position
//
// position object
swagger:model GetUniverseMoonsMoonIDOKBodyPosition
*/
type GetUniverseMoonsMoonIDOKBodyPosition struct {

	// get_universe_moons_moon_id_x
	//
	// x number
	// Required: true
	X *float32 `json:"x"`

	// get_universe_moons_moon_id_y
	//
	// y number
	// Required: true
	Y *float32 `json:"y"`

	// get_universe_moons_moon_id_z
	//
	// z number
	// Required: true
	Z *float32 `json:"z"`
}

/*GetUniverseMoonsMoonIDOKBody get_universe_moons_moon_id_ok
//
// 200 ok object
swagger:model GetUniverseMoonsMoonIDOKBody
*/
type GetUniverseMoonsMoonIDOKBody struct {

	// get_universe_moons_moon_id_moon_id
	//
	// moon_id integer
	// Required: true
	MoonID *int32 `json:"moon_id"`

	// get_universe_moons_moon_id_name
	//
	// name string
	// Required: true
	Name *string `json:"name"`

	// position
	// Required: true
	Position *GetUniverseMoonsMoonIDOKBodyPosition `json:"position"`

	// get_universe_moons_moon_id_system_id
	//
	// The solar system this moon is in
	// Required: true
	SystemID *int32 `json:"system_id"`
}
