package universe

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// GetUniversePlanetsPlanetIDReader is a Reader for the GetUniversePlanetsPlanetID structure.
type GetUniversePlanetsPlanetIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetUniversePlanetsPlanetIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetUniversePlanetsPlanetIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 404:
		result := NewGetUniversePlanetsPlanetIDNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetUniversePlanetsPlanetIDInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetUniversePlanetsPlanetIDOK creates a GetUniversePlanetsPlanetIDOK with default headers values
func NewGetUniversePlanetsPlanetIDOK() *GetUniversePlanetsPlanetIDOK {
	return &GetUniversePlanetsPlanetIDOK{}
}

/*GetUniversePlanetsPlanetIDOK handles this case with default header values.

Information about a planet
*/
type GetUniversePlanetsPlanetIDOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload GetUniversePlanetsPlanetIDOKBody
}

func (o *GetUniversePlanetsPlanetIDOK) Error() string {
	return fmt.Sprintf("[GET /universe/planets/{planet_id}/][%d] getUniversePlanetsPlanetIdOK  %+v", 200, o.Payload)
}

func (o *GetUniversePlanetsPlanetIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetUniversePlanetsPlanetIDNotFound creates a GetUniversePlanetsPlanetIDNotFound with default headers values
func NewGetUniversePlanetsPlanetIDNotFound() *GetUniversePlanetsPlanetIDNotFound {
	return &GetUniversePlanetsPlanetIDNotFound{}
}

/*GetUniversePlanetsPlanetIDNotFound handles this case with default header values.

Planet not found
*/
type GetUniversePlanetsPlanetIDNotFound struct {
	Payload GetUniversePlanetsPlanetIDNotFoundBody
}

func (o *GetUniversePlanetsPlanetIDNotFound) Error() string {
	return fmt.Sprintf("[GET /universe/planets/{planet_id}/][%d] getUniversePlanetsPlanetIdNotFound  %+v", 404, o.Payload)
}

func (o *GetUniversePlanetsPlanetIDNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetUniversePlanetsPlanetIDInternalServerError creates a GetUniversePlanetsPlanetIDInternalServerError with default headers values
func NewGetUniversePlanetsPlanetIDInternalServerError() *GetUniversePlanetsPlanetIDInternalServerError {
	return &GetUniversePlanetsPlanetIDInternalServerError{}
}

/*GetUniversePlanetsPlanetIDInternalServerError handles this case with default header values.

Internal server error
*/
type GetUniversePlanetsPlanetIDInternalServerError struct {
	Payload GetUniversePlanetsPlanetIDInternalServerErrorBody
}

func (o *GetUniversePlanetsPlanetIDInternalServerError) Error() string {
	return fmt.Sprintf("[GET /universe/planets/{planet_id}/][%d] getUniversePlanetsPlanetIdInternalServerError  %+v", 500, o.Payload)
}

func (o *GetUniversePlanetsPlanetIDInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetUniversePlanetsPlanetIDOKBodyPosition get_universe_planets_planet_id_position
//
// position object
swagger:model GetUniversePlanetsPlanetIDOKBodyPosition
*/
type GetUniversePlanetsPlanetIDOKBodyPosition struct {

	// get_universe_planets_planet_id_x
	//
	// x number
	// Required: true
	X *float32 `json:"x"`

	// get_universe_planets_planet_id_y
	//
	// y number
	// Required: true
	Y *float32 `json:"y"`

	// get_universe_planets_planet_id_z
	//
	// z number
	// Required: true
	Z *float32 `json:"z"`
}

/*GetUniversePlanetsPlanetIDOKBody get_universe_planets_planet_id_ok
//
// 200 ok object
swagger:model GetUniversePlanetsPlanetIDOKBody
*/
type GetUniversePlanetsPlanetIDOKBody struct {

	// get_universe_planets_planet_id_name
	//
	// name string
	// Required: true
	Name *string `json:"name"`

	// get_universe_planets_planet_id_planet_id
	//
	// planet_id integer
	// Required: true
	PlanetID *int32 `json:"planet_id"`

	// position
	// Required: true
	Position *GetUniversePlanetsPlanetIDOKBodyPosition `json:"position"`

	// get_universe_planets_planet_id_system_id
	//
	// The solar system this planet is in
	// Required: true
	SystemID *int32 `json:"system_id"`

	// get_universe_planets_planet_id_type_id
	//
	// type_id integer
	// Required: true
	TypeID *int32 `json:"type_id"`
}

/*GetUniversePlanetsPlanetIDNotFoundBody get_universe_planets_planet_id_not_found
//
// Not found
swagger:model GetUniversePlanetsPlanetIDNotFoundBody
*/
type GetUniversePlanetsPlanetIDNotFoundBody struct {

	// get_universe_planets_planet_id_404_not_found
	//
	// Not found message
	// Required: true
	Error *string `json:"error"`
}

/*GetUniversePlanetsPlanetIDInternalServerErrorBody get_universe_planets_planet_id_internal_server_error
//
// Internal server error
swagger:model GetUniversePlanetsPlanetIDInternalServerErrorBody
*/
type GetUniversePlanetsPlanetIDInternalServerErrorBody struct {

	// get_universe_planets_planet_id_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}
