package universe

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetUniverseRegionsRegionIDParams creates a new GetUniverseRegionsRegionIDParams object
// with the default values initialized.
func NewGetUniverseRegionsRegionIDParams() *GetUniverseRegionsRegionIDParams {
	var (
		datasourceDefault = string("tranquility")
		languageDefault   = string("en-us")
	)
	return &GetUniverseRegionsRegionIDParams{
		Datasource: &datasourceDefault,
		Language:   &languageDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetUniverseRegionsRegionIDParamsWithTimeout creates a new GetUniverseRegionsRegionIDParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetUniverseRegionsRegionIDParamsWithTimeout(timeout time.Duration) *GetUniverseRegionsRegionIDParams {
	var (
		datasourceDefault = string("tranquility")
		languageDefault   = string("en-us")
	)
	return &GetUniverseRegionsRegionIDParams{
		Datasource: &datasourceDefault,
		Language:   &languageDefault,

		timeout: timeout,
	}
}

// NewGetUniverseRegionsRegionIDParamsWithContext creates a new GetUniverseRegionsRegionIDParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetUniverseRegionsRegionIDParamsWithContext(ctx context.Context) *GetUniverseRegionsRegionIDParams {
	var (
		datasourceDefault = string("tranquility")
		languageDefault   = string("en-us")
	)
	return &GetUniverseRegionsRegionIDParams{
		Datasource: &datasourceDefault,
		Language:   &languageDefault,

		Context: ctx,
	}
}

/*GetUniverseRegionsRegionIDParams contains all the parameters to send to the API endpoint
for the get universe regions region id operation typically these are written to a http.Request
*/
type GetUniverseRegionsRegionIDParams struct {

	/*XUserAgent
	  Client identifier, takes precedence over User-Agent

	*/
	XUserAgent *string
	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*Language
	  Language to use in the response

	*/
	Language *string
	/*RegionID
	  region_id integer

	*/
	RegionID int32
	/*UserAgent
	  Client identifier, takes precedence over headers

	*/
	UserAgent *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get universe regions region id params
func (o *GetUniverseRegionsRegionIDParams) WithTimeout(timeout time.Duration) *GetUniverseRegionsRegionIDParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get universe regions region id params
func (o *GetUniverseRegionsRegionIDParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get universe regions region id params
func (o *GetUniverseRegionsRegionIDParams) WithContext(ctx context.Context) *GetUniverseRegionsRegionIDParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get universe regions region id params
func (o *GetUniverseRegionsRegionIDParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithXUserAgent adds the xUserAgent to the get universe regions region id params
func (o *GetUniverseRegionsRegionIDParams) WithXUserAgent(xUserAgent *string) *GetUniverseRegionsRegionIDParams {
	o.SetXUserAgent(xUserAgent)
	return o
}

// SetXUserAgent adds the xUserAgent to the get universe regions region id params
func (o *GetUniverseRegionsRegionIDParams) SetXUserAgent(xUserAgent *string) {
	o.XUserAgent = xUserAgent
}

// WithDatasource adds the datasource to the get universe regions region id params
func (o *GetUniverseRegionsRegionIDParams) WithDatasource(datasource *string) *GetUniverseRegionsRegionIDParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the get universe regions region id params
func (o *GetUniverseRegionsRegionIDParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithLanguage adds the language to the get universe regions region id params
func (o *GetUniverseRegionsRegionIDParams) WithLanguage(language *string) *GetUniverseRegionsRegionIDParams {
	o.SetLanguage(language)
	return o
}

// SetLanguage adds the language to the get universe regions region id params
func (o *GetUniverseRegionsRegionIDParams) SetLanguage(language *string) {
	o.Language = language
}

// WithRegionID adds the regionID to the get universe regions region id params
func (o *GetUniverseRegionsRegionIDParams) WithRegionID(regionID int32) *GetUniverseRegionsRegionIDParams {
	o.SetRegionID(regionID)
	return o
}

// SetRegionID adds the regionId to the get universe regions region id params
func (o *GetUniverseRegionsRegionIDParams) SetRegionID(regionID int32) {
	o.RegionID = regionID
}

// WithUserAgent adds the userAgent to the get universe regions region id params
func (o *GetUniverseRegionsRegionIDParams) WithUserAgent(userAgent *string) *GetUniverseRegionsRegionIDParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the get universe regions region id params
func (o *GetUniverseRegionsRegionIDParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WriteToRequest writes these params to a swagger request
func (o *GetUniverseRegionsRegionIDParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	r.SetTimeout(o.timeout)
	var res []error

	if o.XUserAgent != nil {

		// header param X-User-Agent
		if err := r.SetHeaderParam("X-User-Agent", *o.XUserAgent); err != nil {
			return err
		}

	}

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	if o.Language != nil {

		// query param language
		var qrLanguage string
		if o.Language != nil {
			qrLanguage = *o.Language
		}
		qLanguage := qrLanguage
		if qLanguage != "" {
			if err := r.SetQueryParam("language", qLanguage); err != nil {
				return err
			}
		}

	}

	// path param region_id
	if err := r.SetPathParam("region_id", swag.FormatInt32(o.RegionID)); err != nil {
		return err
	}

	if o.UserAgent != nil {

		// query param user_agent
		var qrUserAgent string
		if o.UserAgent != nil {
			qrUserAgent = *o.UserAgent
		}
		qUserAgent := qrUserAgent
		if qUserAgent != "" {
			if err := r.SetQueryParam("user_agent", qUserAgent); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
