package universe

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// GetUniverseSystemsReader is a Reader for the GetUniverseSystems structure.
type GetUniverseSystemsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetUniverseSystemsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetUniverseSystemsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 500:
		result := NewGetUniverseSystemsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetUniverseSystemsOK creates a GetUniverseSystemsOK with default headers values
func NewGetUniverseSystemsOK() *GetUniverseSystemsOK {
	return &GetUniverseSystemsOK{}
}

/*GetUniverseSystemsOK handles this case with default header values.

A list of solar system ids
*/
type GetUniverseSystemsOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []int32
}

func (o *GetUniverseSystemsOK) Error() string {
	return fmt.Sprintf("[GET /universe/systems/][%d] getUniverseSystemsOK  %+v", 200, o.Payload)
}

func (o *GetUniverseSystemsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetUniverseSystemsInternalServerError creates a GetUniverseSystemsInternalServerError with default headers values
func NewGetUniverseSystemsInternalServerError() *GetUniverseSystemsInternalServerError {
	return &GetUniverseSystemsInternalServerError{}
}

/*GetUniverseSystemsInternalServerError handles this case with default header values.

Internal server error
*/
type GetUniverseSystemsInternalServerError struct {
	Payload GetUniverseSystemsInternalServerErrorBody
}

func (o *GetUniverseSystemsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /universe/systems/][%d] getUniverseSystemsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetUniverseSystemsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetUniverseSystemsInternalServerErrorBody get_universe_systems_internal_server_error
//
// Internal server error
swagger:model GetUniverseSystemsInternalServerErrorBody
*/
type GetUniverseSystemsInternalServerErrorBody struct {

	// get_universe_systems_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}
