package universe

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetUniverseSystemsSystemIDParams creates a new GetUniverseSystemsSystemIDParams object
// with the default values initialized.
func NewGetUniverseSystemsSystemIDParams() *GetUniverseSystemsSystemIDParams {
	var (
		datasourceDefault = string("tranquility")
		languageDefault   = string("en-us")
	)
	return &GetUniverseSystemsSystemIDParams{
		Datasource: &datasourceDefault,
		Language:   &languageDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetUniverseSystemsSystemIDParamsWithTimeout creates a new GetUniverseSystemsSystemIDParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetUniverseSystemsSystemIDParamsWithTimeout(timeout time.Duration) *GetUniverseSystemsSystemIDParams {
	var (
		datasourceDefault = string("tranquility")
		languageDefault   = string("en-us")
	)
	return &GetUniverseSystemsSystemIDParams{
		Datasource: &datasourceDefault,
		Language:   &languageDefault,

		timeout: timeout,
	}
}

// NewGetUniverseSystemsSystemIDParamsWithContext creates a new GetUniverseSystemsSystemIDParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetUniverseSystemsSystemIDParamsWithContext(ctx context.Context) *GetUniverseSystemsSystemIDParams {
	var (
		datasourceDefault = string("tranquility")
		languageDefault   = string("en-us")
	)
	return &GetUniverseSystemsSystemIDParams{
		Datasource: &datasourceDefault,
		Language:   &languageDefault,

		Context: ctx,
	}
}

/*GetUniverseSystemsSystemIDParams contains all the parameters to send to the API endpoint
for the get universe systems system id operation typically these are written to a http.Request
*/
type GetUniverseSystemsSystemIDParams struct {

	/*XUserAgent
	  Client identifier, takes precedence over User-Agent

	*/
	XUserAgent *string
	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*Language
	  Language to use in the response

	*/
	Language *string
	/*SystemID
	  system_id integer

	*/
	SystemID int32
	/*UserAgent
	  Client identifier, takes precedence over headers

	*/
	UserAgent *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get universe systems system id params
func (o *GetUniverseSystemsSystemIDParams) WithTimeout(timeout time.Duration) *GetUniverseSystemsSystemIDParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get universe systems system id params
func (o *GetUniverseSystemsSystemIDParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get universe systems system id params
func (o *GetUniverseSystemsSystemIDParams) WithContext(ctx context.Context) *GetUniverseSystemsSystemIDParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get universe systems system id params
func (o *GetUniverseSystemsSystemIDParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithXUserAgent adds the xUserAgent to the get universe systems system id params
func (o *GetUniverseSystemsSystemIDParams) WithXUserAgent(xUserAgent *string) *GetUniverseSystemsSystemIDParams {
	o.SetXUserAgent(xUserAgent)
	return o
}

// SetXUserAgent adds the xUserAgent to the get universe systems system id params
func (o *GetUniverseSystemsSystemIDParams) SetXUserAgent(xUserAgent *string) {
	o.XUserAgent = xUserAgent
}

// WithDatasource adds the datasource to the get universe systems system id params
func (o *GetUniverseSystemsSystemIDParams) WithDatasource(datasource *string) *GetUniverseSystemsSystemIDParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the get universe systems system id params
func (o *GetUniverseSystemsSystemIDParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithLanguage adds the language to the get universe systems system id params
func (o *GetUniverseSystemsSystemIDParams) WithLanguage(language *string) *GetUniverseSystemsSystemIDParams {
	o.SetLanguage(language)
	return o
}

// SetLanguage adds the language to the get universe systems system id params
func (o *GetUniverseSystemsSystemIDParams) SetLanguage(language *string) {
	o.Language = language
}

// WithSystemID adds the systemID to the get universe systems system id params
func (o *GetUniverseSystemsSystemIDParams) WithSystemID(systemID int32) *GetUniverseSystemsSystemIDParams {
	o.SetSystemID(systemID)
	return o
}

// SetSystemID adds the systemId to the get universe systems system id params
func (o *GetUniverseSystemsSystemIDParams) SetSystemID(systemID int32) {
	o.SystemID = systemID
}

// WithUserAgent adds the userAgent to the get universe systems system id params
func (o *GetUniverseSystemsSystemIDParams) WithUserAgent(userAgent *string) *GetUniverseSystemsSystemIDParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the get universe systems system id params
func (o *GetUniverseSystemsSystemIDParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WriteToRequest writes these params to a swagger request
func (o *GetUniverseSystemsSystemIDParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	r.SetTimeout(o.timeout)
	var res []error

	if o.XUserAgent != nil {

		// header param X-User-Agent
		if err := r.SetHeaderParam("X-User-Agent", *o.XUserAgent); err != nil {
			return err
		}

	}

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	if o.Language != nil {

		// query param language
		var qrLanguage string
		if o.Language != nil {
			qrLanguage = *o.Language
		}
		qLanguage := qrLanguage
		if qLanguage != "" {
			if err := r.SetQueryParam("language", qLanguage); err != nil {
				return err
			}
		}

	}

	// path param system_id
	if err := r.SetPathParam("system_id", swag.FormatInt32(o.SystemID)); err != nil {
		return err
	}

	if o.UserAgent != nil {

		// query param user_agent
		var qrUserAgent string
		if o.UserAgent != nil {
			qrUserAgent = *o.UserAgent
		}
		qUserAgent := qrUserAgent
		if qUserAgent != "" {
			if err := r.SetQueryParam("user_agent", qUserAgent); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
