package universe

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetUniverseTypesParams creates a new GetUniverseTypesParams object
// with the default values initialized.
func NewGetUniverseTypesParams() *GetUniverseTypesParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetUniverseTypesParams{
		Datasource: &datasourceDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetUniverseTypesParamsWithTimeout creates a new GetUniverseTypesParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetUniverseTypesParamsWithTimeout(timeout time.Duration) *GetUniverseTypesParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetUniverseTypesParams{
		Datasource: &datasourceDefault,

		timeout: timeout,
	}
}

// NewGetUniverseTypesParamsWithContext creates a new GetUniverseTypesParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetUniverseTypesParamsWithContext(ctx context.Context) *GetUniverseTypesParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetUniverseTypesParams{
		Datasource: &datasourceDefault,

		Context: ctx,
	}
}

/*GetUniverseTypesParams contains all the parameters to send to the API endpoint
for the get universe types operation typically these are written to a http.Request
*/
type GetUniverseTypesParams struct {

	/*XUserAgent
	  Client identifier, takes precedence over User-Agent

	*/
	XUserAgent *string
	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*Page
	  Which page to query

	*/
	Page *int32
	/*UserAgent
	  Client identifier, takes precedence over headers

	*/
	UserAgent *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get universe types params
func (o *GetUniverseTypesParams) WithTimeout(timeout time.Duration) *GetUniverseTypesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get universe types params
func (o *GetUniverseTypesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get universe types params
func (o *GetUniverseTypesParams) WithContext(ctx context.Context) *GetUniverseTypesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get universe types params
func (o *GetUniverseTypesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithXUserAgent adds the xUserAgent to the get universe types params
func (o *GetUniverseTypesParams) WithXUserAgent(xUserAgent *string) *GetUniverseTypesParams {
	o.SetXUserAgent(xUserAgent)
	return o
}

// SetXUserAgent adds the xUserAgent to the get universe types params
func (o *GetUniverseTypesParams) SetXUserAgent(xUserAgent *string) {
	o.XUserAgent = xUserAgent
}

// WithDatasource adds the datasource to the get universe types params
func (o *GetUniverseTypesParams) WithDatasource(datasource *string) *GetUniverseTypesParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the get universe types params
func (o *GetUniverseTypesParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithPage adds the page to the get universe types params
func (o *GetUniverseTypesParams) WithPage(page *int32) *GetUniverseTypesParams {
	o.SetPage(page)
	return o
}

// SetPage adds the page to the get universe types params
func (o *GetUniverseTypesParams) SetPage(page *int32) {
	o.Page = page
}

// WithUserAgent adds the userAgent to the get universe types params
func (o *GetUniverseTypesParams) WithUserAgent(userAgent *string) *GetUniverseTypesParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the get universe types params
func (o *GetUniverseTypesParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WriteToRequest writes these params to a swagger request
func (o *GetUniverseTypesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	r.SetTimeout(o.timeout)
	var res []error

	if o.XUserAgent != nil {

		// header param X-User-Agent
		if err := r.SetHeaderParam("X-User-Agent", *o.XUserAgent); err != nil {
			return err
		}

	}

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	if o.Page != nil {

		// query param page
		var qrPage int32
		if o.Page != nil {
			qrPage = *o.Page
		}
		qPage := swag.FormatInt32(qrPage)
		if qPage != "" {
			if err := r.SetQueryParam("page", qPage); err != nil {
				return err
			}
		}

	}

	if o.UserAgent != nil {

		// query param user_agent
		var qrUserAgent string
		if o.UserAgent != nil {
			qrUserAgent = *o.UserAgent
		}
		qUserAgent := qrUserAgent
		if qUserAgent != "" {
			if err := r.SetQueryParam("user_agent", qUserAgent); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
