package user_interface

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewPostUIOpenwindowContractParams creates a new PostUIOpenwindowContractParams object
// with the default values initialized.
func NewPostUIOpenwindowContractParams() *PostUIOpenwindowContractParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &PostUIOpenwindowContractParams{
		Datasource: &datasourceDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewPostUIOpenwindowContractParamsWithTimeout creates a new PostUIOpenwindowContractParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewPostUIOpenwindowContractParamsWithTimeout(timeout time.Duration) *PostUIOpenwindowContractParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &PostUIOpenwindowContractParams{
		Datasource: &datasourceDefault,

		timeout: timeout,
	}
}

// NewPostUIOpenwindowContractParamsWithContext creates a new PostUIOpenwindowContractParams object
// with the default values initialized, and the ability to set a context for a request
func NewPostUIOpenwindowContractParamsWithContext(ctx context.Context) *PostUIOpenwindowContractParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &PostUIOpenwindowContractParams{
		Datasource: &datasourceDefault,

		Context: ctx,
	}
}

/*PostUIOpenwindowContractParams contains all the parameters to send to the API endpoint
for the post ui openwindow contract operation typically these are written to a http.Request
*/
type PostUIOpenwindowContractParams struct {

	/*XUserAgent
	  Client identifier, takes precedence over User-Agent

	*/
	XUserAgent *string
	/*ContractID
	  The contract to open

	*/
	ContractID int32
	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*Token
	  Access token to use, if preferred over a header

	*/
	Token *string
	/*UserAgent
	  Client identifier, takes precedence over headers

	*/
	UserAgent *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the post ui openwindow contract params
func (o *PostUIOpenwindowContractParams) WithTimeout(timeout time.Duration) *PostUIOpenwindowContractParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post ui openwindow contract params
func (o *PostUIOpenwindowContractParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post ui openwindow contract params
func (o *PostUIOpenwindowContractParams) WithContext(ctx context.Context) *PostUIOpenwindowContractParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post ui openwindow contract params
func (o *PostUIOpenwindowContractParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithXUserAgent adds the xUserAgent to the post ui openwindow contract params
func (o *PostUIOpenwindowContractParams) WithXUserAgent(xUserAgent *string) *PostUIOpenwindowContractParams {
	o.SetXUserAgent(xUserAgent)
	return o
}

// SetXUserAgent adds the xUserAgent to the post ui openwindow contract params
func (o *PostUIOpenwindowContractParams) SetXUserAgent(xUserAgent *string) {
	o.XUserAgent = xUserAgent
}

// WithContractID adds the contractID to the post ui openwindow contract params
func (o *PostUIOpenwindowContractParams) WithContractID(contractID int32) *PostUIOpenwindowContractParams {
	o.SetContractID(contractID)
	return o
}

// SetContractID adds the contractId to the post ui openwindow contract params
func (o *PostUIOpenwindowContractParams) SetContractID(contractID int32) {
	o.ContractID = contractID
}

// WithDatasource adds the datasource to the post ui openwindow contract params
func (o *PostUIOpenwindowContractParams) WithDatasource(datasource *string) *PostUIOpenwindowContractParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the post ui openwindow contract params
func (o *PostUIOpenwindowContractParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithToken adds the token to the post ui openwindow contract params
func (o *PostUIOpenwindowContractParams) WithToken(token *string) *PostUIOpenwindowContractParams {
	o.SetToken(token)
	return o
}

// SetToken adds the token to the post ui openwindow contract params
func (o *PostUIOpenwindowContractParams) SetToken(token *string) {
	o.Token = token
}

// WithUserAgent adds the userAgent to the post ui openwindow contract params
func (o *PostUIOpenwindowContractParams) WithUserAgent(userAgent *string) *PostUIOpenwindowContractParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the post ui openwindow contract params
func (o *PostUIOpenwindowContractParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WriteToRequest writes these params to a swagger request
func (o *PostUIOpenwindowContractParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	r.SetTimeout(o.timeout)
	var res []error

	if o.XUserAgent != nil {

		// header param X-User-Agent
		if err := r.SetHeaderParam("X-User-Agent", *o.XUserAgent); err != nil {
			return err
		}

	}

	// query param contract_id
	qrContractID := o.ContractID
	qContractID := swag.FormatInt32(qrContractID)
	if qContractID != "" {
		if err := r.SetQueryParam("contract_id", qContractID); err != nil {
			return err
		}
	}

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	if o.Token != nil {

		// query param token
		var qrToken string
		if o.Token != nil {
			qrToken = *o.Token
		}
		qToken := qrToken
		if qToken != "" {
			if err := r.SetQueryParam("token", qToken); err != nil {
				return err
			}
		}

	}

	if o.UserAgent != nil {

		// query param user_agent
		var qrUserAgent string
		if o.UserAgent != nil {
			qrUserAgent = *o.UserAgent
		}
		qUserAgent := qrUserAgent
		if qUserAgent != "" {
			if err := r.SetQueryParam("user_agent", qUserAgent); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
