package user_interface

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewPostUIOpenwindowInformationParams creates a new PostUIOpenwindowInformationParams object
// with the default values initialized.
func NewPostUIOpenwindowInformationParams() *PostUIOpenwindowInformationParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &PostUIOpenwindowInformationParams{
		Datasource: &datasourceDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewPostUIOpenwindowInformationParamsWithTimeout creates a new PostUIOpenwindowInformationParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewPostUIOpenwindowInformationParamsWithTimeout(timeout time.Duration) *PostUIOpenwindowInformationParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &PostUIOpenwindowInformationParams{
		Datasource: &datasourceDefault,

		timeout: timeout,
	}
}

// NewPostUIOpenwindowInformationParamsWithContext creates a new PostUIOpenwindowInformationParams object
// with the default values initialized, and the ability to set a context for a request
func NewPostUIOpenwindowInformationParamsWithContext(ctx context.Context) *PostUIOpenwindowInformationParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &PostUIOpenwindowInformationParams{
		Datasource: &datasourceDefault,

		Context: ctx,
	}
}

/*PostUIOpenwindowInformationParams contains all the parameters to send to the API endpoint
for the post ui openwindow information operation typically these are written to a http.Request
*/
type PostUIOpenwindowInformationParams struct {

	/*XUserAgent
	  Client identifier, takes precedence over User-Agent

	*/
	XUserAgent *string
	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*TargetID
	  The target to open

	*/
	TargetID int32
	/*Token
	  Access token to use, if preferred over a header

	*/
	Token *string
	/*UserAgent
	  Client identifier, takes precedence over headers

	*/
	UserAgent *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the post ui openwindow information params
func (o *PostUIOpenwindowInformationParams) WithTimeout(timeout time.Duration) *PostUIOpenwindowInformationParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post ui openwindow information params
func (o *PostUIOpenwindowInformationParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post ui openwindow information params
func (o *PostUIOpenwindowInformationParams) WithContext(ctx context.Context) *PostUIOpenwindowInformationParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post ui openwindow information params
func (o *PostUIOpenwindowInformationParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithXUserAgent adds the xUserAgent to the post ui openwindow information params
func (o *PostUIOpenwindowInformationParams) WithXUserAgent(xUserAgent *string) *PostUIOpenwindowInformationParams {
	o.SetXUserAgent(xUserAgent)
	return o
}

// SetXUserAgent adds the xUserAgent to the post ui openwindow information params
func (o *PostUIOpenwindowInformationParams) SetXUserAgent(xUserAgent *string) {
	o.XUserAgent = xUserAgent
}

// WithDatasource adds the datasource to the post ui openwindow information params
func (o *PostUIOpenwindowInformationParams) WithDatasource(datasource *string) *PostUIOpenwindowInformationParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the post ui openwindow information params
func (o *PostUIOpenwindowInformationParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithTargetID adds the targetID to the post ui openwindow information params
func (o *PostUIOpenwindowInformationParams) WithTargetID(targetID int32) *PostUIOpenwindowInformationParams {
	o.SetTargetID(targetID)
	return o
}

// SetTargetID adds the targetId to the post ui openwindow information params
func (o *PostUIOpenwindowInformationParams) SetTargetID(targetID int32) {
	o.TargetID = targetID
}

// WithToken adds the token to the post ui openwindow information params
func (o *PostUIOpenwindowInformationParams) WithToken(token *string) *PostUIOpenwindowInformationParams {
	o.SetToken(token)
	return o
}

// SetToken adds the token to the post ui openwindow information params
func (o *PostUIOpenwindowInformationParams) SetToken(token *string) {
	o.Token = token
}

// WithUserAgent adds the userAgent to the post ui openwindow information params
func (o *PostUIOpenwindowInformationParams) WithUserAgent(userAgent *string) *PostUIOpenwindowInformationParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the post ui openwindow information params
func (o *PostUIOpenwindowInformationParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WriteToRequest writes these params to a swagger request
func (o *PostUIOpenwindowInformationParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	r.SetTimeout(o.timeout)
	var res []error

	if o.XUserAgent != nil {

		// header param X-User-Agent
		if err := r.SetHeaderParam("X-User-Agent", *o.XUserAgent); err != nil {
			return err
		}

	}

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	// query param target_id
	qrTargetID := o.TargetID
	qTargetID := swag.FormatInt32(qrTargetID)
	if qTargetID != "" {
		if err := r.SetQueryParam("target_id", qTargetID); err != nil {
			return err
		}
	}

	if o.Token != nil {

		// query param token
		var qrToken string
		if o.Token != nil {
			qrToken = *o.Token
		}
		qToken := qrToken
		if qToken != "" {
			if err := r.SetQueryParam("token", qToken); err != nil {
				return err
			}
		}

	}

	if o.UserAgent != nil {

		// query param user_agent
		var qrUserAgent string
		if o.UserAgent != nil {
			qrUserAgent = *o.UserAgent
		}
		qUserAgent := qrUserAgent
		if qUserAgent != "" {
			if err := r.SetQueryParam("user_agent", qUserAgent); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
