package wars

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// GetWarsWarIDKillmailsReader is a Reader for the GetWarsWarIDKillmails structure.
type GetWarsWarIDKillmailsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetWarsWarIDKillmailsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetWarsWarIDKillmailsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 422:
		result := NewGetWarsWarIDKillmailsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetWarsWarIDKillmailsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetWarsWarIDKillmailsOK creates a GetWarsWarIDKillmailsOK with default headers values
func NewGetWarsWarIDKillmailsOK() *GetWarsWarIDKillmailsOK {
	return &GetWarsWarIDKillmailsOK{}
}

/*GetWarsWarIDKillmailsOK handles this case with default header values.

A list of killmail IDs and hashes
*/
type GetWarsWarIDKillmailsOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetWarsWarIDKillmailsOKBodyItems0
}

func (o *GetWarsWarIDKillmailsOK) Error() string {
	return fmt.Sprintf("[GET /wars/{war_id}/killmails/][%d] getWarsWarIdKillmailsOK  %+v", 200, o.Payload)
}

func (o *GetWarsWarIDKillmailsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetWarsWarIDKillmailsUnprocessableEntity creates a GetWarsWarIDKillmailsUnprocessableEntity with default headers values
func NewGetWarsWarIDKillmailsUnprocessableEntity() *GetWarsWarIDKillmailsUnprocessableEntity {
	return &GetWarsWarIDKillmailsUnprocessableEntity{}
}

/*GetWarsWarIDKillmailsUnprocessableEntity handles this case with default header values.

War not found
*/
type GetWarsWarIDKillmailsUnprocessableEntity struct {
	Payload GetWarsWarIDKillmailsUnprocessableEntityBody
}

func (o *GetWarsWarIDKillmailsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /wars/{war_id}/killmails/][%d] getWarsWarIdKillmailsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetWarsWarIDKillmailsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetWarsWarIDKillmailsInternalServerError creates a GetWarsWarIDKillmailsInternalServerError with default headers values
func NewGetWarsWarIDKillmailsInternalServerError() *GetWarsWarIDKillmailsInternalServerError {
	return &GetWarsWarIDKillmailsInternalServerError{}
}

/*GetWarsWarIDKillmailsInternalServerError handles this case with default header values.

Internal server error
*/
type GetWarsWarIDKillmailsInternalServerError struct {
	Payload GetWarsWarIDKillmailsInternalServerErrorBody
}

func (o *GetWarsWarIDKillmailsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /wars/{war_id}/killmails/][%d] getWarsWarIdKillmailsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetWarsWarIDKillmailsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetWarsWarIDKillmailsOKBodyItems0 get_wars_war_id_killmails_200_ok
//
// 200 ok object
swagger:model GetWarsWarIDKillmailsOKBodyItems0
*/
type GetWarsWarIDKillmailsOKBodyItems0 struct {

	// get_wars_war_id_killmails_killmail_hash
	//
	// A hash of this killmail
	// Required: true
	KillmailHash *string `json:"killmail_hash"`

	// get_wars_war_id_killmails_killmail_id
	//
	// ID of this killmail
	// Required: true
	KillmailID *int32 `json:"killmail_id"`
}

/*GetWarsWarIDKillmailsUnprocessableEntityBody get_wars_war_id_killmails_unprocessable_entity
//
// Unprocessable entity
swagger:model GetWarsWarIDKillmailsUnprocessableEntityBody
*/
type GetWarsWarIDKillmailsUnprocessableEntityBody struct {

	// get_wars_war_id_killmails_422_unprocessable_entity
	//
	// Unprocessable entity message
	// Required: true
	Error *string `json:"error"`
}

/*GetWarsWarIDKillmailsInternalServerErrorBody get_wars_war_id_killmails_internal_server_error
//
// Internal server error
swagger:model GetWarsWarIDKillmailsInternalServerErrorBody
*/
type GetWarsWarIDKillmailsInternalServerErrorBody struct {

	// get_wars_war_id_killmails_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}
